/*
  
  SPS嚙踝蕭嚙踝蕭嚙?
  
  
*/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Net;
using System.Data.SqlClient;
using System.Xml;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.Portal;
using Microsoft.SharePoint.Portal.Search;
using Microsoft.SharePoint.Portal.Topology;
using System.IO;
using System.Security.Principal;
using System.Runtime.InteropServices;
using System.Configuration;
using System.Text;
using System.Text.RegularExpressions;
//using UnicomKM.Lib.WebService;
namespace AoDiSi.DCC.DataAccess
{

	public enum FileType {Text,Attach}
		
	public enum ReturnInfo
	{
		Successful = 0,
		SiteNotFind,
		FileNotFind,
		UnknownError
	}
	public enum DocumentStatus
	{
		UnReview = 1,	//嚙豎審嚙?0)
		Normal,		//皏嚙踝蕭`(2)
		Overdue 	//嚙盤嚙?4)
	}
	/// <summary>
	/// Class1 嚙踝蕭嚙皺嚙緯?嚙瘠

	/// </summary>
	public class SPSHelper
	{
		private string errStr;
		private static string errStr1;
		private DataSet ds;				
		public const int BUFFERSIZE = 10000;
		private string documentGUID;
		private string strServerURL="";
		private string strDomainName="";
		private string strServerRelativeUrl="";
		private string strsitesearch ; 
		//private string strTempDocumentLibrary = "";
		//嚙踝蕭嚙褕迎蕭嚙踝蕭嚙璀

	
			
		/// <summary>
		/// 嚙箱嚙緙嚙踝蕭A嚙締鴝叉rverURL,DomainName
		/// </summary>
		public SPSHelper()
		{
			//URL:http://sytech-zgx:8000
			strServerURL=System.Configuration.ConfigurationSettings.AppSettings["ServerUrl"].ToString();
			strDomainName=System.Configuration.ConfigurationSettings.AppSettings["DomainName"].ToString();
			strsitesearch=System.Configuration .ConfigurationSettings.AppSettings["SiteName"].ToString();
			//strTempDocumentLibrary = System.Configuration .ConfigurationSettings.AppSettings["TempDocumentLibrary"].ToString();


		}
		#region //--propertiess
	
		public static string GetStaticErrMsg
		{
			get
			{
				return errStr1;
			}
			set
			{
				errStr1=value;
			}
		}
		/// <summary>
		/// 
		/// GetErrMsg:^嚙羯H嚙?
		/// </summary>
		public string GetErrMsg
		{
			get
			{
				return errStr;
			}
			set
			{
				errStr=value;
			}
		}


		/// <summary>
		/// 
		/// GetDataSet:嚙緻d繸爰萰嚙踝蕭GDataSet
		/// </summary>
		public DataSet GetDataSet
		{
			get
			{
				return ds;
			}
			set
			{
				ds=value;
			}
		}


		public static string GetSiteName
		{
			get
			{
				return System.Configuration.ConfigurationSettings.AppSettings["SiteName"].ToString();
			}
		}
		public static string GetTempDocLibName
		{
			get
			{
				return System.Configuration.ConfigurationSettings.AppSettings["TempDocumentLibrary"].ToString();
			}
		}


		/// <summary>
		/// GetDocumentGuid:嚙緻嚙踝蕭嚙褕迎蕭GUID
		/// 			/// </summary>
		public string GetDocumentGuid
		{
			get
			{
				return documentGUID;
			}
			set
			{
				documentGUID=value;
			}
		}

		
		/// <summary>
		/// 嚙踝蕭嚙踝蕭嚙褕上嚙褒迎蕭嚙諛農麊務橘蕭嚙踝蕭url,嚙緘嚙瘦/sites/sz/.../aaa.doc
		/// </summary>
		public string GetDocumentUrl
		{
			get
			{
				return strServerRelativeUrl;
			}
			set
			{
				strServerRelativeUrl=value;
			}
		}


		public static string GetTemplateDocumentLibrary
		{
			get
			{
				return System.Configuration.ConfigurationSettings.AppSettings["TemplateDocumentLibrary"].ToString();
			}
		}

		/// <summary>
		/// 嚙踝蕭spsA嚙褓橘蕭嚙踝蕭URL
		/// </summary>
		public static string GetServerUrl
		{
			get
			{
				return System.Configuration.ConfigurationSettings.AppSettings["ServerUrl"].ToString();
			}
		}


		/// <summary>
		/// 嚙踝蕭SPSA嚙褓橘蕭嚙踝蕭嚙璀鴘務橘蕭嚙磕嚙?
		/// </summary>
		public static string GetDomainName
		{
			get
			{
				return System.Configuration.ConfigurationSettings.AppSettings["DomainName"].ToString();
			}
		}


		/// <summary>
		/// 嚙踝蕭嚙磅PSA嚙褓橘蕭嚙踝蕭嚙諄上

		/// </summary>
		public static string GetSpsUid
		{
			get
			{
				return System.Configuration.ConfigurationSettings.AppSettings["SPSAdmin"].ToString();
			}
		}


		/// <summary>
		/// 嚙踝蕭嚙磅PSA嚙褓橘蕭嚙踝蕭嚙諄上嶆迎蕭嚙皺嚙碼

		/// </summary>
		public static string GetSpsPwd
		{
			get
			{
				return System.Configuration.ConfigurationSettings.AppSettings["SPSPassword"].ToString();
			}
		}

		#endregion		

		#region SearchFullText

		/// <summary>
		/// 在指定的文档库中进行全文检索

		/// </summary>
		/// <param name="strKey">关键词</param>
		/// <param name="scopeFolderUrl">检索范围</param>
		/// <param name="includePass">是否包括过期的文档</param>
		public void SearchDocuments(string strKey,string scopeFolderUrl,bool includePass)
		{
			//strKey="sharepoint";
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();	
			string strSiteName = @"/sites/"+SPSHelper.GetSiteName;

			try
			{

				SPWeb web = new SPSite(strServerURL).AllWebs[strSiteName];

				SPFolder folder = web.Folders[scopeFolderUrl];

				SPQuery query = new SPQuery();
				query.Folder = folder;

				query.Query = "<Where><Eq><FieldRef Name='Status'/><Value Type='Text'>Completed</Value></Eq></Where>";

//				SPListItemCollection items = query;
//
//				foreach (SPListItem item in items)
//				{
//					Response.Write(SPEncode.HtmlEncode(item["Title"].ToString()) + "<BR>");
//				}

//				pcx = PortalApplication.GetContext();
//				sSearchAppName = pcx.SearchApplicationName;
//				string SQL =null;
//				qp = new QueryProvider(sSearchAppName); 
//				if(AttribScope=="1")
//				{ 
//					SQL =   "select \"DAV:displayname\"," +
//						"\"urn:schemas-microsoft-com:office:office#ows_expr_DocNumber\","+
//						"\"urn:schemas-microsoft-com:office:office#ows_expr_KMID\","+
//						"\"urn:schemas-microsoft-com:office:office#ows_expr_StatusCode\","+
//						"\"urn:schemas-microsoft-com:office:office#ows_expr_Title\","+
//						"\"urn:schemas-microsoft-com:office:office#ows_expr_Version\","+
//						"\"DAV:href\"," +
//						"\"DAV:creationdate\","+
//						"\"DAV:getlastmodified\","+
//						"\"DAV:getcontentlength\""+
//						" from (TABLE Portal_Content..Scope() UNION ALL TABLE Non_Portal_Content..Scope())" +
//						" where freetext('\""+strKey+"\"') "+
//						" Order by \"DAV:getlastmodified\" DESC";
//				}
//				else 
//				{
//					SQL =   "select \"DAV:displayname\"," +
//						"\"urn:schemas-microsoft-com:office:office#ows_expr_DocNumber\","+
//						"\"urn:schemas-microsoft-com:office:office#ows_expr_KMID\","+
//						"\"urn:schemas-microsoft-com:office:office#ows_expr_StatusCode\","+
//						"\"urn:schemas-microsoft-com:office:office#ows_expr_Title\","+
//						"\"urn:schemas-microsoft-com:office:office#ows_expr_Version\","+
//						"\"DAV:href\"," +
//						"\"DAV:creationdate\","+
//						"\"DAV:getlastmodified\","+
//						"\"DAV:getcontentlength\""+
//						" from (TABLE Portal_Content..Scope() UNION ALL TABLE Non_Portal_Content..Scope())" +
//						" where freetext('\""+strKey+"\"') "+
//						" and not (\"urn:schemas-microsoft-com:office:office#ows_expr_StatusCode\"= 'UnReview')"+
//						" and not (\"urn:schemas-microsoft-com:office:office#ows_expr_StatusCode\"= 'Overdue')"+
//						" Order by \"DAV:getlastmodified\" DESC";
//				}
//				return qp.Execute(SQL);
					
			}
			catch(Exception ex)
			{
				//				this.errStr=ex.Message.ToString();
				//				return null;
				throw ex;
			}
			finally
			{
//				qp=null;
//				pcx=null;
				//				wic.Undo();
			}
			
		}			

		/// <summary>
		/// 在Portal范围内进行全文检索		
		/// </summary>
		/// <param name="strKey">关键词</param>
		/// <param name="AttribScope">1:包括过期的文档, 0:不包括已过期的文档</param>
		/// <returns>DataSet</returns>
		public  DataSet  SearchFullText(string strKey,string AttribScope)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			PortalContext pcx=null;
			string siteName = SPSHelper.GetSiteName;
			string sSearchAppName = "";
			QueryProvider qp =null;
			try
			{
				pcx = PortalApplication.GetContext();
				sSearchAppName = pcx.SearchApplicationName;
				string SQL =null;
				qp = new QueryProvider(sSearchAppName); 
				if(AttribScope=="1")
				{ 
					SQL = "select \"DAV:displayname\"," +
						"\"DAV:href\"," +
						"\"urn:schemas-microsoft-com:office:office#ows_SiteName\"," +
						//"\"urn:schemas-microsoft-com:office:office#expr_DocId\","+
						"\"urn:schemas-microsoft-com:office:office#DocId\""+
						" from Non_Portal_Content..Scope()"+
						//" from (TABLE Portal_Content..Scope() UNION ALL TABLE Non_Portal_Content..Scope())" +
						" where freetext('\"" + strKey + "\"') " +
						" and (\"urn:schemas.microsoft.com:sharepoint:portal:isdocument\" = 1) " + //只检索文档

						" and (\"DAV:href\"LIKE '%" + siteName + "/%')" + //只在指定的站点内检索

						" Order by \"DAV:getlastmodified\" DESC";
				}
				else 
				{
					SQL = "select \"DAV:displayname\"," +
						"\"DAV:href\"," +
						"\"urn:schemas-microsoft-com:office:office#ows_SiteName\"," +
						"\"urn:schemas-microsoft-com:office:office#DocId\""+
						" from Non_Portal_Content..Scope()"+
						" where freetext('\"" + strKey + "\"') " +
						" and (\"DAV:href\"LIKE '%" + siteName + "/%')" + //只在指定的站点内检索

						" and (\"urn:schemas.microsoft.com:sharepoint:portal:isdocument\" = 1) " + //只检索文档

						" Order by \"DAV:getlastmodified\" DESC";
				}
				return qp.Execute(SQL);
					
			}
			catch(Exception ex)
			{
				//				this.errStr=ex.Message.ToString();
				//				return null;
				throw ex;
			}
			finally
			{
				qp=null;
				pcx=null;
				wic.Undo();
			}
			
		}

		/// <summary>
		/// 在Site范围内检索文档

		/// </summary>
		/// <param name="strKey">关键词</param>
		/// <param name="AttribScope">1:包括过期的文档, 0:不包括已过期的文档</param>
		/// <returns>DataSet</returns>
		public  SPSearchResultCollection SearchDocuments(string strKey,string AttribScope)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;
			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				SPWeb web = new SPSite(strServerURL).OpenWeb(Site);
				SPSearchResultCollection oRootDocResults = web.SearchListItems(strKey);
				foreach(SPSearchResult result in oRootDocResults)
				{
					System.Diagnostics.Debug.Write(result.Title + "  " + result.Url  + result.ListName);
				}
				return oRootDocResults;
					
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
			
		}


		#endregion SearchFullText

		#region  UploadTempTextFile
		/// <summary>
		/// W???韝知?嚙?慦綽蕭嚙踝蕭嚙踝蕭,嚙稷嚙?慦摻RL:"/sites/sz/.../aaa.doc"
		/// </summary>
		/// <param name="strSiteUrl">嚙?s憒究ite					嚙課：嚙窯嚙窯嚙踝蕭??嚙踝蕭TeamSite:sz</param>
		/// <param name="strFileLocalPath">嚙?搌嚙踝蕭W?嚙?慦綽蕭?	嚙課：c:\dd\ddddd.doc</param>
		/// /// <param name="strFileLocalPath">??嚙踝蕭W韟不??嚙箠嚙磕 嚙課：D29BF59E-E013-1234-94DF-603045080A5D</param>
		/// <returns>?嚙踝蕭?W?憭后嚙踝蕭URL.嚙緘嚙瘦/sites/sz/.../aaa.doc</returns>
		public string UploadTempTextFile(string strSiteUrl,string strFileLocalPath,string strFileName,Stream InputFileStream)
		{

			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
				
			SPWeb site=null;
			SPFile upTextFile=null;

			//嚙磕?嚙稿嚙踝蕭嚙賢的嚙編URL
			string strNewUrl1="";

			string strFileExtension=System.IO.Path.GetExtension(strFileLocalPath);
			string LstrFileName=strFileName;
			strFileName+=strFileExtension;
			string LstrSiteUrl=strSiteUrl;
				
	
			string SiteName=strSiteUrl;
			string Site=@"/sites/"+strSiteUrl;
	
			strSiteUrl=@Site+"/Shared%20Documents";
			try
			{

				site = new SPSite(strServerURL).AllWebs[Site];
					
				//嚙踝蕭?嚙踝蕭?嚙緩璁?d

				site.AllowUnsafeUpdates=true;
					
				string strFolder="Shared%20Documents/TempFolder";;
				if (!site.GetFolder(strFolder).Exists)
				{
					CreateFolder(SiteName,"TempFolder");
				}

				//嚙賢的URL
				strNewUrl1=strServerURL+strSiteUrl+"/TempFolder/"+strFileName;
					
				//嚙磕?嚙踝蕭嚙?
				if (site.GetFile(strNewUrl1).Exists)
				{
					DeleteFile(LstrSiteUrl,"Shared%20Documents/TempFolder",strFileName);
				}
				upTextFile = site.Files.Add(strNewUrl1, ConvertToStream(InputFileStream));
					
				///W?憭伐蕭嚙?撌踝蕭嚙?

				///strServerURL:A?顗器URL + strSiteUrl:Teamsite嚙踝蕭嚙磕? + SrcFileFoder:?嚙踝蕭嚙踝蕭?

				///strNewFolder=strServerURL+strSiteUrl+"/"+SrcFileFoder;//SPSW韝的嚙?
				if(upTextFile==null)
					return "";
				else
					return upTextFile.ServerRelativeUrl;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return "";
			}
			finally
			{
				if(site!=null)
					site.Close();
				upTextFile=null;
				wic.Undo();
			}
				
		}

			
		#endregion  UploadTempTextFile

		#region UploadTempTextAttachFile
//		/// <summary>
//		/// 堣W???嚙踝蕭?嚙?慦?嚙踝蕭嚙踝蕭
//		/// </summary>
//		/// <param name="strSiteUrl"></param>
//		/// <param name="strFileLocalPath">嚙?搛?a} 嚙瘦E:\UnicomKM\ddd.doc</param>
//		/// <param name="strTextFileName">嚙踝蕭嚙踝蕭嚙瘦UID(??韟陵i嚙磕)嚙瘦D29BF59E-E013-1234-94DF-603045080A5D</param>
//		/// <param name="InputFileStream"></param>
//		/// <returns></returns>
//		public string UploadTempTextAttachFile(string strSiteUrl,string strFileLocalPath,string strTextFileName,Stream InputFileStream)
//		{
//					
//			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
//			SPWeb site=null;
//			SPFile upTextFile=null;
//
//			//嚙磕?嚙稿嚙踝蕭嚙賢的嚙編URL
//			//C:\Documents and Settings\Administrator\My Documents\Google嚙篌嚙稻files\nav_current.gif
//			string strNewUrl1="";
//			//---嚙瘦ooglej嚙稻files嚙踝蕭嚙璀嚙磐嚙瞌_files嚙?files----------------------------------------
//			string delimStr = @"\";
//			char [] delimiter = delimStr.ToCharArray();
//			string [] split = null;
//				
//			split=strFileLocalPath.Split(delimiter);
//			int len=split.Length;
//
//			string strFolderExt=split[len-2];
//			int len2=0;
//			//----?帢o嚙踝蕭WAAA.DOC韟的?嚙踝蕭嚙踝蕭GAAAO.DOC-------------
//			int pos2=strFolderExt.LastIndexOf(".");
//			if(pos2>=0)
//			{
//				len2=strFolderExt.Length;
//				//string strFolderName=strFolderExt.Substring(0,pos2);
//				strFolderExt=strFolderExt.Substring(pos2,len2-pos2);
//			}
//			pos2=strFolderExt.LastIndexOf("_");
//			if(pos2>=0)
//			{
//				len2=strFolderExt.Length;
//				//string strFolderName=strFolderExt.Substring(0,pos2);
//				strFolderExt=strFolderExt.Substring(pos2,len2-pos2);
//			}
//			string FileFolderName="";
//			///------------------------------------------------------------------------------------
//			///
//			string LstrSiteUrl=strSiteUrl;
//			string LstrTextFileName=strTextFileName;
//			string LstrFileLocalPath=strFileLocalPath;
//
//			//氻W?嚙稿嚙踝蕭嚙?撌踝蕭嚙?嚙課在嚙踝蕭顗熒sURL				
//
//			string strFileName=System.IO.Path.GetFileName(strFileLocalPath);
//
//			string Site=@"/sites/"+strSiteUrl;
//
//
//			strSiteUrl=@Site+"/Shared%20Documents";
//			
//			try
//			{
//				site = new SPSite(strServerURL).AllWebs[Site];
//				//嚙踝蕭?嚙踝蕭?嚙緩璁?d
//
//				site.AllowUnsafeUpdates=true;
//
//
//				//--?嚙諍保嚙編嚙踝蕭嚙?撌踝蕭嚙??顗漱嚙?---------------------------------
//					
//				if (strFolderExt==".files")
//				{
//					FileFolderName="files."+LstrTextFileName;
//				}
//				else
//				{
//					FileFolderName="_files."+LstrTextFileName;
//				}
//				string folder1="Shared%20Documents/TempFolder/"+FileFolderName;
//					
//				if (!site.GetFolder(folder1).Exists)
//				{
//					CreateFolder(LstrSiteUrl,"Shared%20Documents/TempFolder",FileFolderName);
//				}
//
//				if (site.GetFolder(folder1).Exists)
//				{
//					strNewUrl1=strServerURL+Site+"/"+folder1+"/"+strFileName;
//				}
//
//				if (site.GetFile(strNewUrl1).Exists)
//				{
//					DeleteFile(LstrSiteUrl,folder1,strFileName);
//				}
//				upTextFile = site.Files.Add(strNewUrl1, ConvertToStream(InputFileStream));
//				return upTextFile.ServerRelativeUrl;
//			}
//			catch(Exception msg)
//			{
//				errStr=msg.Message.ToString();
//				return "";
//			}
//			finally
//			{
//				if(site!=null)
//					site.Close();
//				upTextFile=null;
//				wic.Undo();
//			}
//				
//		}

			
		#endregion  UploadTempTextAttachFile

		#region DeleteAllTempFile
		/// <summary>
		/// ???嚙磐嚙瑾?嚙踝蕭?嚙?(]憟含嚙踝蕭嚙畿?憛瘀蕭嚙踝蕭?嚙瞌阞嚙踝蕭嚙?)
		/// </summary>
		/// <param name="strSiteName">Site Name :gd</param>
		/// <param name="strFileName">嚙踝蕭W	:aaa.doc</param>
		public bool DeleteAllTempFile(string strSiteName,string strFileName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site=null;
			try
			{
				site=new SPSite(strServerURL).AllWebs["sites/"+strSiteName];
				site.AllowUnsafeUpdates=true;
				
				//----?o韟惜嚙磕AAA.DOC韟的?嚙踝蕭嚙踝蕭GAAAO.DOC-------------
				int pos2=strFileName.LastIndexOf(".");
				int len2=strFileName.Length;
				string strFileName1=strFileName.Substring(0,pos2);
				string strFileName2=strFileName.Substring(pos2,len2-pos2);


				DeleteFile(strSiteName,"Shared%20Documents/TempFolder",strFileName);				//---?仱嚙踝蕭嚙踝蕭


				if (site.GetFolder("Shared%20Documents/TempFolder/"+strFileName1).Exists)
				{
					DeleteFolder(strSiteName,"Shared%20Documents/TempFolder",strFileName1);			//---?撠?蕭嚙踝蕭嚙?

				}
				string strFolder1="Shared%20Documents/TempFolder/"+"files."+strFileName1;
				string strFolder2="Shared%20Documents/TempFolder/"+"_files."+strFileName1;
				
				if (site.GetFolder(strFolder1).Exists)
				{
					DeleteFolder(strSiteName,"Shared%20Documents/TempFolder","files."+strFileName1);			//---?饇ㄔ嚙踝蕭慦?嚙踝蕭嚙踝蕭?
				}
				if (site.GetFolder(strFolder2).Exists)
				{
					DeleteFolder(strSiteName,"Shared%20Documents/TempFolder","_files."+strFileName1);			//---?饇ㄔ嚙踝蕭慦?嚙踝蕭嚙踝蕭?
				}
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
				
		}			
		#endregion DeleteAllTempFile

		#region DeleteTempTextFile
		/// <summary>
		/// ???饇ㄙ嚙踝蕭Y嚙瑾?嚙踝蕭?嚙?(]憟含嚙踝蕭嚙畿?憛瘀蕭嚙踝蕭?)
		/// </summary>
		/// <param name="strSiteName">Site Name 嚙?gd</param>
		/// <param name="strFileName">狺嚙磕	嚙?aaa.doc</param>
		public bool DelelteTempTextFile(string strSiteName,string strFileName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site=null;
			try
			{
				site=new SPSite(strServerURL).AllWebs["sites/"+strSiteName];
				site.AllowUnsafeUpdates=true;
				
				//----?珣o嚙踝蕭WAAA.DOC韟的?嚙踝蕭嚙踝蕭GAAAO.DOC-------------
				int pos2=strFileName.LastIndexOf(".");
				int len2=strFileName.Length;
				string strFileName1=strFileName.Substring(0,pos2);
				string strFileName2=strFileName.Substring(pos2,len2-pos2);


				DeleteFile(strSiteName,"Shared%20Documents/TempFolder",strFileName);				//---?仱嚙踝蕭嚙踝蕭

					

				string strFolder1="Shared%20Documents/TempFolder/"+"files."+strFileName1;
				string strFolder2="Shared%20Documents/TempFolder/"+"_files."+strFileName1;
				
				if (site.GetFolder(strFolder1).Exists)
				{
					DeleteFolder(strSiteName,"Shared%20Documents/TempFolder","files."+strFileName1);			//---?撠?蕭嚙踝蕭嚙?

				}
				if (site.GetFolder(strFolder2).Exists)
				{
					DeleteFolder(strSiteName,"Shared%20Documents/TempFolder","_files."+strFileName1);			//---?饇ㄙ嚙踝蕭嚙?

				}
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
				
		}			
		#endregion DelelteTempTextFile

		#region DeleteTempTextAttachFile
		/// <summary>
		/// ???饇ㄙ嚙踝蕭Y嚙瑾?嚙踝蕭?嚙?慦?嚙踝蕭嚙踝蕭
		/// </summary>
		/// <param name="strSiteName">Site Name			嚙?gd</param>
		/// <param name="strTextGuid">狴嚙踝蕭W憒迎蕭??GUID	嚙?D29BF59E-E013-1234-94DF-603045080A5D</param>
		/// <param name="strFileName">狺嚙磕			嚙?aaa.doc</param>
		public bool DeleteTempTextAttachFile(string strSiteName,string strTextGuid,string strFileName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site=null;
			try
			{
				site=new SPSite(strServerURL).AllWebs["sites/"+strSiteName];
				site.AllowUnsafeUpdates=true;

				string strFolder1="Shared%20Documents/TempFolder/"+"files."+strTextGuid;
				string strFolder2="Shared%20Documents/TempFolder/"+"_files."+strTextGuid;
				
				if (site.GetFolder(strFolder1).Exists)
				{
					DeleteFile(strSiteName,"Shared%20Documents/TempFolder/files."+strTextGuid,strFileName);			
				}
				if (site.GetFolder(strFolder2).Exists)
				{
					DeleteFile(strSiteName,"Shared%20Documents/TempFolder/_files."+strTextGuid,strFileName);			
				}
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
				
		}			
		#endregion DeleteTempTextAttachFile

		#region DeleteTempAttachFile
		/// <summary>
		/// ?珧嚙??嚙踝蕭嚙磐嚙瑾?嚙踝蕭?嚙?慦綽蕭嚙踝蕭嚙?
		/// </summary>
		/// <param name="strSiteName">Site Name			嚙?gd</param>
		/// <param name="strOldFileName">狴嚙踝蕭嚙踝蕭WG	韟”:aaa.doc</param>
		/// <param name="strFileName">猁嚙踝蕭嚙?		嚙?bbb.doc</param>
		public bool DeleteTempAttachFile(string strSiteName,string strOldFileName,string strFileName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			try
			{
				string LstrOldFileName=strOldFileName;
				int pos=LstrOldFileName.LastIndexOf(".");
				int len=LstrOldFileName.Length;
				string FileOldName=LstrOldFileName.Substring(0,pos);
				
				DeleteFile(strSiteName,"Shared%20Documents/TempFolder/"+FileOldName,strFileName);
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
					
			}
			finally
			{
				wic.Undo();
			}
		}
		#endregion DeleteTempAttachFile

		#region  ConfirmUpLoad
		/// <summary>
		/// 嚙踝蕭?怐嚙?嚙?慦綽蕭W?嚙稽嚙稽嚙璀嚙踝蕭嚙踝蕭O阞嚙稷

		/// </summary>
		/// <param name="strSiteUrl">嚙?s憒究ite 嚙課：嚙窯嚙窯嚙踝蕭??嚙踝蕭TeamSite:sz</param>
		/// <param name="strOldFileName">??嚙踝蕭嚙踝蕭W GXXXXX.doc 韟‘嚙???嚙箠嚙磕</param>
		/// <param name="strNewFileName">嚙踝蕭嚙踝蕭顗漱??? GGZ1001001</param>
		/// <param name="ClientFileName">憛在嚙?搌嚙踝蕭嚙踝蕭嚙踝蕭W:嚙諄于嚙踝蕭嚙踝蕭嚙踟中迎蕭?嚙踝蕭嚙?埵W嚙?嚙瘠</param>
		/// <returns></returns>
		public string ConfirmUpLoad(string strSiteUrl,string strOldFileName,string strNewFileName,string ClientFileName)
		{
				
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site=null;
				
			bool IsAttchDir=false;

			string LstrSiteUrl=strSiteUrl;
			string LstrOldFileName=strOldFileName;
			string LstrNewFileName=strNewFileName;

			//----?嚙緻嚙踝蕭WAAA.DOC韟的?嚙踝蕭嚙踝蕭GAAAO.DOC-------------
			int pos=LstrOldFileName.LastIndexOf(".");
			int len=LstrOldFileName.Length;
			string FileExtension=LstrOldFileName.Substring(pos,len-pos);
			string FileOldName=LstrOldFileName.Substring(0,pos);

			//----?伀o嚙踝蕭WClientFileName韟的?嚙踝蕭嚙踝蕭GAAAO.DOC-------------

			int pos2=ClientFileName.LastIndexOf(".");
			int len2=ClientFileName.Length;
			string ClientFileName2=ClientFileName.Substring(pos2,len2-pos2);
			string ClientFileName1=ClientFileName.Substring(0,pos2);

			string Site=@"/sites/"+LstrSiteUrl;

			string strSharedDocument=@Site+"/Shared%20Documents";
			
			try
			{
					
				site = new SPSite(strServerURL).AllWebs[Site];
				//氻嚙?嚙踝蕭?嚙緩璁?d

				site.AllowUnsafeUpdates=true;


				string textsrc2=Site+"/Shared%20Documents/TempFolder/"+LstrOldFileName;		//嚙賢的嚙練

				string textdesc2=Site+"/Shared%20Documents/"+strNewFileName+FileExtension;	//鼽目迎蕭嚙踝蕭嚙賢的嚙練


				//---嚙窯峔??嚙踝蕭?顗漫狾嚙踝蕭嚙?
				string AttachFolder="Shared%20Documents/TempFolder/"+FileOldName;
					
				//----嚙窯峔嚙踝蕭嚙踝蕭?--------------------------------------------------------------
				if (site.GetFolder(AttachFolder).Exists)
				{
					IsAttchDir=true;
						
					SPFileCollection strFiles3=site.GetFolder(AttachFolder).Files;
					if (!site.GetFolder("Shared%20Documents/"+LstrNewFileName).Exists)
					{
						CreateFolder(LstrSiteUrl,LstrNewFileName);//嚙諍立一?嚙瘡嚙踝蕭嚙踝蕭嚙?W韟的嚙?

					}
					int kk=strFiles3.Count;
					for(int i=0;i<kk;i++)
					{

						string desc4="Shared%20Documents/"+LstrNewFileName+"/"+strFiles3[i].Name;
							
						strFiles3[i].CopyTo(desc4,true);

					}
					DeleteFolder(LstrSiteUrl,"Shared%20Documents/TempFolder",FileOldName);
				}
					
					
				string strFolder1="Shared%20Documents/TempFolder/"+"files."+FileOldName;
				string strFolder2="Shared%20Documents/TempFolder/"+"_files."+FileOldName;

				//--?埵嚙?嚙踝蕭嚙踝蕭?顗滷嚙?嚙磊`峔謋選蕭嚙踝蕭----------------------------------------------------------
				if ((!site.GetFolder(strFolder1).Exists)&&(!site.GetFolder(strFolder2).Exists))
				{
					if(!IsAttchDir)
					{
						SPFileCollection CopyFiles = site.GetFolder("Shared%20Documents/TempFolder").Files;
						string NewFile="Shared%20Documents/"+strNewFileName+FileExtension;
						if(site.GetFile(Site+"/"+NewFile).Exists)
						{
							this.DeleteFile(LstrSiteUrl,strNewFileName+FileExtension);
						}
						
						CopyFiles[LstrOldFileName].CopyTo(NewFile,true);
					}
					else
					{
						//---HTML韞縣b嚙踝蕭?怮O嚙編嚙箴嚙緯嚙踝蕭?e?銈佗蕭蚹A鵅主嚙緯嚙瞌:?嚙踝蕭嚙踝蕭顗漸?

						string oldFolder2="";
						string newFolder2="";
						CopyFileCrossSite(textsrc2,textdesc2,oldFolder2,newFolder2,LstrNewFileName);
					}
				}

				if (site.GetFolder(strFolder1).Exists)
				{

					//---HTML堨嚙踝蕭b嚙踝蕭?怮O嚙編嚙箴嚙緯嚙踝蕭?e?銈佗蕭蚹A鵅主嚙緯嚙瞌:?嚙踝蕭嚙踝蕭顗漸?

					string oldFolder1=ClientFileName1;
					string newFolder1=strNewFileName;

					CopyFileCrossSite(textsrc2,textdesc2,oldFolder1,newFolder1,LstrNewFileName);

					//----嚙窯峔?貔踝蕭嚙?--------------------------------------------------------------
					SPFileCollection strFolderFiles1=site.GetFolder(strFolder1).Files;
					CreateFolder(LstrSiteUrl,LstrNewFileName+".files");//嚙諍立一?_files嚙?

					foreach(SPFile myfile in strFolderFiles1)
					{
						string desc2=Site+"/Shared%20Documents/"+LstrNewFileName+".files/"+myfile.Name;
						string src2=Site+"/"+strFolder1+"/"+myfile.Name;
						CopyFileCrossSite(src2,desc2);

					}
					DeleteFolder(LstrSiteUrl,"Shared%20Documents/TempFolder","files."+FileOldName);
				} 
				//======================================================================================================
				if (site.GetFolder(strFolder2).Exists)
				{

					//---HTML堨嚙踝蕭b嚙踝蕭?怮O嚙編嚙箴嚙緯嚙踝蕭?e?銈佗蕭蚹A鵅主嚙緯嚙瞌:?嚙踝蕭嚙踝蕭顗漸?

					string oldFolder2=ClientFileName1;
					string newFolder2=strNewFileName;
					CopyFileCrossSite(textsrc2,textdesc2,oldFolder2,newFolder2,newFolder2);

					//----嚙窯峔?貔踝蕭嚙?--------------------------------------------------------------
					SPFileCollection strFolderFiles2=site.GetFolder(strFolder2).Files;
					CreateFolder(LstrSiteUrl,LstrNewFileName+"_files");//嚙諍立一?_files嚙?
					//---媢M?TempFolder嚙踝蕭?U韝的_files嚙?堣嚙踝蕭嚙踝蕭狾嚙踝蕭嚙?
					foreach(SPFile myfile in strFolderFiles2)
					{
						string desc2=Site+"/Shared%20Documents/"+LstrNewFileName+"_files/"+myfile.Name;
						string src2=Site+"/"+strFolder2+"/"+myfile.Name;
						CopyFileCrossSite(src2,desc2);
							

					}
					DeleteFolder(LstrSiteUrl,"Shared%20Documents/TempFolder","_files."+FileOldName);
				} 
				//--?饇ㄜ?鴠選蕭嚙踝蕭------------------------------------------------------
				DeleteFile(LstrSiteUrl,"Shared%20Documents/TempFolder",LstrOldFileName);
				

				return strSharedDocument+"/"+strNewFileName+FileExtension;
					
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return "";
			}
			finally
			{
				if (site!=null)
					site.Close();
				wic.Undo();
			}
		}

		#endregion  ConfirmUpLoad

		#region  CancelUpLoad
		/// <summary>
		/// 嚙踝蕭?嚙?慦綽蕭W?嚙稽嚙稽嚙璀嚙踝蕭嚙踝蕭O阞嚙稷

		/// </summary>
		/// <param name="strSiteUrl">嚙?s憒究ite			嚙課：嚙窯嚙窯嚙踝蕭??嚙踝蕭TeamSite:sz</param>
		/// <param name="strTextFileName">??嚙踝蕭嚙踝蕭W		嚙課：XXXXX.doc 嚙踝蕭???嚙箠嚙磕</param>
		public bool CancelUpLoad(string strSiteUrl,string strTextFileName)
		{
				
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site=null;
		
			string LstrSiteUrl=strSiteUrl;
			string LstrTextFileName=strTextFileName;

			int pos=LstrTextFileName.LastIndexOf(".");
			int len=LstrTextFileName.Length;
				
			string FileExtension=LstrTextFileName.Substring(pos,len-pos);
			string FileOldName=LstrTextFileName.Substring(0,pos);
			string Site=@"/sites/"+LstrSiteUrl;

			string strSharedDocument=@Site+"/Shared%20Documents";
			
			try
			{
					
				site = new SPSite(strServerURL).AllWebs[Site];
				//嚙踝蕭?嚙踝蕭?嚙緩璁?d

				site.AllowUnsafeUpdates=true;

				//--?嚙?鴠選蕭嚙踝蕭------------------------------------------------------
				DeleteFile(LstrSiteUrl,"Shared%20Documents/TempFolder",strTextFileName);
					
				//---嚙窯峔謋選蕭嚙踝蕭files顗漱嚙?

				string strFolder1="Shared%20Documents/TempFolder/"+"files."+FileOldName;
				string strFolder2="Shared%20Documents/TempFolder/"+"_files."+FileOldName;
				string AttachFolder="Shared%20Documents/TempFolder/"+FileOldName;
				if (site.GetFolder(strFolder1).Exists)
				{
					DeleteFolder(LstrSiteUrl,"Shared%20Documents/TempFolder","files."+FileOldName);
				} 
				if (site.GetFolder(strFolder2).Exists)
				{
					DeleteFolder(LstrSiteUrl,"Shared%20Documents/TempFolder","_files."+FileOldName);
				} 
				//-----pG韟爬s嚙踝蕭嚙踝蕭?A??鞳除------------------------------------------
				if (site.GetFolder(AttachFolder).Exists)
				{
					DeleteFolder(LstrSiteUrl,"Shared%20Documents/TempFolder",FileOldName);
				}
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
		}

			
		#endregion  CancelUpLoad
	
		#region DeleteFileAllText
		/// <summary>
		/// ?嚙踝蕭嚙踝蕭嚙踝蕭嚙踝蕭嚙踝蕭?嚙?(]憟含嚙踝蕭嚙畿?憛瘀蕭嚙踝蕭?嚙諄迎蕭嚙踝蕭?)
		/// </summary>
		/// <param name="strSiteName">Site Name :gd</param>
		/// <param name="strFileName">嚙踝蕭W	:aaa.doc</param>
		public bool DeleteFileAllText(string strSiteName,string strFileName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site=null;
			try
			{
				site=new SPSite(strServerURL).AllWebs["sites/"+strSiteName];
				site.AllowUnsafeUpdates=true;
				
				//----?o韟惜嚙磕AAA.DOC韟的?嚙踝蕭嚙踝蕭GAAAO.DOC-------------
				string strFileName1 = RemoveExtension(strFileName);
				string strFullFileName = strFileName;

				if (site.GetFile(strFullFileName).Exists)
				{
					DeleteFile(strFullFileName);						//---?仱嚙踝蕭嚙踝蕭
				}
				if (site.GetFolder(strFileName1).Exists)						//---?撠?蕭嚙踝蕭慦綽蕭嚙踝蕭嚙?
				{
					SPFolder folder = site.GetFolder(strFileName1);
					folder.ParentFolder.SubFolders.Delete(strFileName1);
					//DeleteFolder(strSiteName,strFileName1);						
				}

				string strFolder1 = strFileName1+"-files";
				SPFolder resourceFolder = site.GetFolder(strFolder1);
				if (resourceFolder.Exists)
				{
					resourceFolder.ParentFolder.SubFolders.Delete(strFileName1 + "-files");
					//DeleteFolder(strSiteName,strFileName1 + "-files");			//---?饇ㄙ嚙踝蕭嚙?
				}
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
		}			
		#endregion DeleteFileAllText

		#region 私有帮助方法
		/// <summary>
		/// q]饃尼tWeb嚙罵嚙踝蕭嚙踝蕭oWeb嚙罵
		/// </summary>
		/// <param name="strFileUrl">]嚙緣Web嚙罵嚙踝蕭嚙磕</param>
		/// <returns>Web嚙罵</returns>
		private string RemoveName(string fileUrl)
		{
			if(fileUrl == "") return "";
			int len = fileUrl.Length;
			int pos = fileUrl.LastIndexOf("/");
			if(pos < 0) return fileUrl;
			return fileUrl.Substring(0,pos);			
		}
		/// <summary>
		/// 嚙緻嚙稽嚙緣Web嚙罵嚙踝蕭嚙磕

		/// </summary>
		/// <param name="strFileUrl">]韟尼t嚙罵嚙踝蕭嚙磕</param>
		/// <returns>韟不嚙稽嚙緣嚙罵嚙踝蕭嚙磕</returns>
		private string RemoveWebPath(string fileUrl)
		{
			if(fileUrl == "") return "";
			int len = fileUrl.Length;
			int pos = fileUrl.LastIndexOf("/");
			if(pos < 0) return fileUrl;
			return fileUrl.Substring(pos + 1,len - pos -1);
		}

		/// <summary>
		/// 嚙緻嚙稽嚙緣嚙踝蕭嚙窮嚙罵嚙踝蕭嚙磕
		/// </summary>
		/// <param name="localPathName"></param>
		/// <returns></returns>
		private string RemoveLocalPath(string localPathName)
		{
			if(localPathName == "") return "";
			int len = localPathName.Length;
			int pos = localPathName.LastIndexOf("\\");
			if(pos < 0) return localPathName;
			return localPathName.Substring(pos + 1,len - pos -1);
		}

		/// <summary>
		/// ?o韟惜嚙踝蕭]嚙緣X簧i嚙磕嚙踝蕭嚙踝蕭W
		/// </summary>
		/// <param name="fileName">]韟尼tX簧i嚙磕嚙踝蕭嚙踝蕭W</param>
		/// <returns>韟不嚙稽嚙緣X簧i嚙磕嚙踝蕭嚙踝蕭W</returns>
		private string RemoveExtension(string fileName)
		{
			if(fileName == "") return "";
			int pos=fileName.LastIndexOf(".");
			int len=fileName.Length;
			if(pos < 0) return fileName;
			return fileName.Substring(0, pos);
		}

		/// <summary>
		/// ?o韟惜嚙踝蕭]嚙緣X簧i嚙磕嚙踝蕭嚙踝蕭W
		/// </summary>
		/// <param name="fileName">]韟尼tX簧i嚙磕嚙踝蕭嚙踝蕭W</param>
		/// <returns>韟不嚙稽嚙緣X簧i嚙磕嚙踝蕭嚙踝蕭W</returns>
		private string GetExtension(string fileName)
		{
			if(fileName == "") return "";
			int pos=fileName.LastIndexOf(".");
			int len=fileName.Length;
			if(pos < 0) return fileName;
			return fileName.Substring(pos, len - pos);
		}

		private string[] FileSplit(string FileName)
		{					
			//----获得文件名AAA.DOC的两部分：AAA与.DOC-------------
			string [] split = new string[2];
			int pos2=FileName.LastIndexOf(".");
			int len2=FileName.Length;
			split[0]=FileName.Substring(0,pos2);
			split[1]=FileName.Substring(pos2,len2-pos2);
			return split;
		}

		private void CopyStream(Stream inStream, Stream outStream)
		{
			try
			{
				inStream.Position =0;
				byte [] buffer = new byte[1024];
				for (;;)
				{
					int numBytesRead = inStream.Read(buffer, 0,buffer.Length);
					if (numBytesRead <= 0)
						break;

					outStream.Write(buffer, 0, numBytesRead);
				}
					
			}
			catch(Exception ex)
			{
				throw ex;
			}
				
		}

		#endregion

		/// <summary>
		/// ?韟除嚙踝蕭嚙踝蕭嚙踝蕭嚙踝蕭?嚙?(]憟含嚙踝蕭嚙畿?憛瘀蕭嚙踝蕭?B嚙踝蕭顜貝M嚙課佗蕭嚙踝蕭嚙踝蕭)
		/// </summary>
		/// <param name="strFileName">]t韞孛|嚙踝蕭嚙踝蕭W	sites/kms/Shared%20Documents/049303/aaa.doc</param>
		public bool DeleteFileText(string fileUrl,string deptCode)
		{
			if(fileUrl == "" ||deptCode == "") return true;

			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site=null;
			try
			{
				site = new SPSite(strServerURL).AllWebs["sites/" + SPSHelper.GetSiteName];
				site.AllowUnsafeUpdates=true;

				//?憒得嚙踝蕭嚙稽嚙緣嚙罵嚙踝蕭嚙磕

				//----?o韟惜嚙磕AAA.DOC韟的?嚙踝蕭嚙踝蕭GAAAO.DOC-------------
				string fileNameNoPath = RemoveWebPath(fileUrl);

				string fileNameNoExtension = RemoveExtension(fileNameNoPath);

				string strFullFileName=this.strServerURL + fileUrl;
				if (site.GetFile(strFullFileName).Exists)
				{
					SPFileCollection delFiles = site.Folders["Shared%20Documents"].SubFolders[deptCode].Files;
					delFiles.Delete("Shared%20Documents/" + deptCode + "/" + fileNameNoPath);
				}

				//玊R嚙踝蕭嚙踝蕭嚙踝蕭

				string attachFolder = "Shared%20Documents/" + deptCode + "/" + fileNameNoExtension;

				if(site.GetFolder(attachFolder).Exists)
				{
					site.Folders["Shared%20Documents/" + deptCode].SubFolders.Delete(attachFolder);
				}

				//顜豆R嚙踝蕭嚙赭源嚙踝蕭

				string strFolder1 = "Shared%20Documents/" + deptCode + "/" + fileNameNoExtension + "-files";
				
				if (site.GetFolder(strFolder1).Exists)
				{
					site.Folders["Shared%20Documents/" + deptCode].SubFolders.Delete(strFolder1);
				}
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
			return true;
		}						
		/// <summary>
		/// 顜迂qSite嚙踝蕭嚙磋嚙踝蕭嚙踝蕭
		/// </summary>
		/// <param name="fileeUrl">嚙豎刪嚙踝蕭嚙踝蕭]]鞳布A嚙窮嚙罷嚙稷 嚙?sites/Shared%20Documents/kaifa/bbb.jpg</param>
		public bool DeleteFile(string fileUrl)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			try
			{
				SPWeb site = new SPSite(strServerURL).AllWebs["/sites/" + SPSHelper.GetSiteName];
					

				//----狶R嚙踝蕭嚙踝蕭嚙?撌踝蕭嚙?-------------------------------------
				site.AllowUnsafeUpdates = true;

				SPFile deleteFile = site.GetFile(fileUrl);
				if (!deleteFile.Exists) return true;
				deleteFile.ParentFolder.Files.Delete(fileUrl);
				


				//					SPFileCollection delFiles = site.Folders[folder].Files;
				//					delFiles.Delete(folder + "/" + fileNameNoPath);
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
				
			}
			finally
			{
				wic.Undo();
			}
		}

		/// <summary>
		/// ?饇ㄔ嚙踝蕭嚙踝蕭嚙踝蕭嚙?嚙?慦綽蕭嚙踝蕭嚙?		/// </summary>
		/// <param name="strSiteName">Site Name			嚙?gd</param>
		/// <param name="strOldFileName">狴嚙踝蕭嚙踝蕭WG	韟”:aaa.doc</param>
		/// <param name="strFileName">猁嚙踝蕭嚙?		嚙?bbb.doc</param>
		public bool DeleteFileAttach(string strSiteName,string strOldFileName,string strFileName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			try
			{
				string LstrOldFileName=strOldFileName;
				int pos=LstrOldFileName.LastIndexOf(".");
				int len=LstrOldFileName.Length;
				string FileOldName=LstrOldFileName.Substring(0,pos);
					
				DeleteFile(strSiteName,"Shared%20Documents/"+FileOldName,strFileName);
					
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
				
			}
			finally
			{
				wic.Undo();
			}
		}


		#region [文件操作]
		
		/// <summary>
		/// 上传文件到WSS指定的SPDocumentLibrary中

		/// </summary>
		/// <param name="id">新文件的GUID</param>
		/// <param name="file">用户上传的文件</param>
		/// <param name="folderName">目录的地址如:/DocLib/ddd/dee/</param>
		/// <param name="userName">当前用户的登录名称</param>
		/// <returns>SPFile的实例</returns>
		public SPFile UploadFile(string id,System.Web.HttpPostedFile file,string folderName,string userName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;
			SPFile upTextFile = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			SPUser user = null;
			string fileName = System.IO.Path.GetFileName(file.FileName);
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//----嚙踝蕭嚙衛選蕭site嚙編hared document警嚙踝蕭嚙踝蕭--------------------------
				SPWeb web=new SPSite(strServerURL).OpenWeb(Site);
				//user = web.Users[userName];
				web.AllowUnsafeUpdates = true;

				
				SPFolder folder = web.GetFolder(folderName);//[SPSHelper.GetTemplateDocumentLibrary];
				
				byte[] bytes = ConvertToStream(file.InputStream);
				upTextFile = folder.Files.Add(folder.Url + "/" + fileName,bytes,true);//user,user,DateTime.Now,DateTime.Now);				
				//upTextFile.
				SPListItem myitem = upTextFile.Item;
				myitem["DocId"] = id;
				myitem.Update();

				return upTextFile;
			}
			catch(SPException se)
			{
				errStr = se.ErrorCode.ToString();
				errStr += se.Message;
				throw se;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return null;
			}
			finally
			{
				if(site!=null)
					site.Close();
				upTextFile=null;
				wic.Undo();
			}
				
		}
		

		/// <summary>
		/// 上传文件到WSS指定的SPDocumentLibrary中

		/// </summary>
		/// <param name="id">新文件的GUID</param>
		/// <param name="content">包含文件内容的byte[]数组</param>
		/// <param name="fileName">文件的名称</param>
		/// <param name="folderName">目录的ServerRelativeUrl</param>
		/// <param name="userName">操作此功能的用户</param>
		/// <returns>SPFile的实例</returns>
		public SPFile UploadFile(string id,byte[] content,string fileName,string folderName,string userName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;
			SPFile upTextFile = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//上传到指定的目录中．
				SPWeb web=new SPSite(strServerURL).OpenWeb(Site);

				web.AllowUnsafeUpdates = true;

				SPFolder folder = web.GetFolder(folderName);
				
				//upTextFile = folder.Files.Add(folder.Url + "/" + fileName,content,user,user,DateTime.Now,DateTime.Now);				
				upTextFile = folder.Files.Add(folder.Url + "/" + fileName,content,true);//user,user,DateTime.Now,DateTime.Now);
				SPListItem myitem = upTextFile.Item;
				myitem["DocId"] = id;
				myitem.Update();

				return upTextFile;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
				
		}
		

		/// <summary>
		/// 用sourceFileUrl的内容替换destFileUrl的内容.
		/// 并删除sourceFileUrl;
		/// </summary>
		/// <param name="sourcFileUrl">源文件URL地址,如:/doclib1/temprory/管理子标准.doc</param>
		/// <param name="destFileUrl">要替换内容的文件,如:DocLib/程序子标准/管理子标准.doc</param>
		/// <param name="userName">操作者</param>
		/// <returns>新版本</returns>
		public SPFileVersion SaveTo(string sourcFileUrl,string destFileUrl,string userName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			//SPUser user = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//上传到指定的目录中．
				SPWeb web=new SPSite(strServerURL).OpenWeb(Site);
				web.AllowUnsafeUpdates = true;

				SPFile sourceFile = web.GetFile(sourcFileUrl);
				SPFile destFile = web.GetFile(destFileUrl);

				destFile.SaveBinary(sourceFile.OpenBinary());
				return destFile.Versions[destFile.Versions.Count-1];//返回最大的Version
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
				
		}

		/// <summary>
		/// 用content的内容替换destFileUrl的内容.
		/// </summary>
		/// <param name="content">byte[]保存的新内容</param>
		/// <param name="destFileUrl">要替换内容的文件地址,如:DocLib/程序子标准/管理子标准.doc</param>
		/// <param name="userName">操作者</param>
		/// <returns>SPFileVersion表示的新版本</returns>
		public SPFileVersion SaveTo(byte[] content,string destFileUrl,string userName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			//SPUser user = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//上传到指定的目录中．
				SPWeb web=new SPSite(strServerURL).OpenWeb(Site);
				web.AllowUnsafeUpdates = true;

				SPFile destFile = web.GetFile(destFileUrl);

				destFile.SaveBinary(content);
				return destFile.Versions[destFile.Versions.Count-1];//返回最大的Version
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
				
		}

		/// <summary>
		/// 在站点内移动文件
		/// </summary>
		/// <param name="fileUrl">需移动文件的绝对路径(ServerRelativeUrl)</param>
		/// <param name="destFolderUrl">目标目录的绝对路径(ServerRelativeUrl)</param>
		/// <returns>SPFile的实例</returns>
		public SPFile Move(string fileUrl,string destFolderUrl)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;

			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;
			string newName = fileUrl.Substring(fileUrl.LastIndexOf("/"),fileUrl.Length - fileUrl.LastIndexOf("/"));
			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//打开站点
				SPWeb web=new SPSite(strServerURL).OpenWeb(Site);
				//打开允许不安全更新

				web.AllowUnsafeUpdates = true;
				
				//取得文件
				SPFile beforeFile = web.GetFile(fileUrl);
				
				//取得目标目录
				SPFolder folder = web.GetFolder(destFolderUrl);

				//移动文件
				beforeFile.MoveTo(folder.Url + newName,true);
				
				return beforeFile;
			}
			catch(Exception ex)
			{
				this.errStr = ex.Message;
				throw ex;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}	
		}
		/// <summary>
		/// 在站点内改变文件内容后移动到指定的目录下
		/// </summary>
		/// <param name="fileUrl">需移动文件的绝对路径(ServerRelativeUrl)</param>
		/// <param name="destFolderUrl">目标目录的绝对路径(ServerRelativeUrl)</param>
		/// <param name="content">改变的文件内容</param>
		/// <returns>SPFile的实例</returns>
		public SPFile Move(string fileUrl,string destFolderUrl,byte[] content)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;

			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;
			string newName = fileUrl.Substring(fileUrl.LastIndexOf("/"),fileUrl.Length - fileUrl.LastIndexOf("/"));
			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//打开站点
				SPWeb web=new SPSite(strServerURL).OpenWeb(Site);
				//打开允许不安全更新

				web.AllowUnsafeUpdates = true;
				
				//取得文件
				SPFile beforeFile = web.GetFile(fileUrl);
				//改变文件的内容

				beforeFile.SaveBinary(content);
				//取得目标目录
				SPFolder folder = web.GetFolder(destFolderUrl);

				//移动文件
				beforeFile.MoveTo(folder.Url + newName,true);
				
				return beforeFile;
			}
			catch(Exception ex)
			{
				this.errStr = ex.Message;
				throw ex;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}	
		}
		
		/// <summary>
		/// 嚙磕?嚙踝蕭嚙踝蕭嚙踝蕭?嚙?慦綽蕭嚙踝蕭嚙?		/// </summary>
		/// <param name="strFileLocalPath">嚙?搌嚙踝蕭W?嚙?慦綽蕭?		嚙課：c:\dd\ssss.doc</param>
		/// <param name="strTextFileName">嚙踝蕭嚙踝蕭嚙踝蕭W]??韟＆i嚙磕嚙稷			嚙課：GD100100101.htm</param>
		/// <param name="InputFileStream"></param>
		/// <returns>?嚙踝蕭?W?憭后嚙踝蕭URL.嚙緘嚙瘦/sites/sz/.../aaa.doc</returns>
		public string UploadAttachFile(string localPathName,string contentUrl,string deptCode,Stream InputFileStream)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();	

			SPWeb site = null;

			string siteUrl = @"/sites/" + SPSHelper.GetSiteName;

			string fileNoPathName = RemoveLocalPath(localPathName);
			
			try
			{
				site = new SPSite(strServerURL).AllWebs[siteUrl];
				//嚙踝蕭嚙踫祥嚙踝蕭嚙請堆蕭嚙踝蕭

				site.AllowUnsafeUpdates=true;

				string contentNameNoExtension = RemoveExtension(RemoveWebPath(contentUrl));

				string folderUrl = "Shared%20Documents/" + deptCode + "/" + contentNameNoExtension;

				SPFolder newFolder = site.GetFolder(siteUrl + "/" + folderUrl);
				if(!newFolder.Exists)
					newFolder = site.Folders.Add(siteUrl + "/" + folderUrl);
				
				if(!newFolder.Exists) return "";

				//Encoding encode = System.Text.Encoding.Default; 
				//StreamReader readStream = new StreamReader(InputFileStream,encode);
					
				//string str=readStream.ReadToEnd();


				//byte[] bytes = System.Text.Encoding.Default.GetBytes(str);

				SPFile file = newFolder.Files.Add(newFolder.ServerRelativeUrl + "/" + fileNoPathName,ConvertToStream(InputFileStream),true);

				//if (newFolder.Files[newFolder.ServerRelativeUrl + "/" + fileNoPathName].Exists)
				//{
				//	DeleteFile(LstrSiteUrl,folder,strFileName);
				//}
				//upTextFile = site.Files.Add(strNewUrl1, ConvertToStream(InputFileStream));
				if(file.Exists)	return file.ServerRelativeUrl;
				else return "";

			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return "";
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
				
		}

		/// <summary>
		/// W?擗伐蕭嚙踝蕭嚙踝蕭?嚙?慦?嚙踝蕭嚙踝蕭
		/// </summary>
		/// <param name="strFileLocalPath">嚙?搌嚙踝蕭W?嚙?慦綽蕭?		嚙課：c:\dd\ssss.jpg</param>
		/// <param name="strFileName">嚙踝蕭嚙踝蕭嚙踝蕭W]??韟＆i嚙磕嚙稷			嚙課：GD100100101.htm</param>
		/// <param name="InputFileStream"></param>
		/// <returns>?嚙踝蕭?W?憭后嚙踝蕭URL.嚙緘嚙瘦/sites/sz/.../aaa.doc</returns>
		public string UploadResourceFile(string localPathName,string contentUrl,string deptCode,Stream InputFileStream)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();	

			string siteUrl= SPSHelper.GetSiteName;

			//---嚙瘦ooglej嚙稻files嚙踝蕭嚙璀嚙磐嚙瞌_files嚙?files----------------------------------------
			//C:\Documents and Settings\Administrator\My Documents\Google庢j嚙稻files\nav_current.gif
			
			string delimStr = @"\";
			char [] delimiter = delimStr.ToCharArray();
			string [] split = null;
				
			split=localPathName.Split(delimiter);

			int len=split.Length;
			string strFolderExt=split[len-2];
			int len2=0;
			//----?嚙緻嚙踝蕭嚙罵嚙碼簧i嚙磕

			int pos2=strFolderExt.LastIndexOf(".");
			if(pos2>=0)
			{
				len2=strFolderExt.Length;
				strFolderExt=strFolderExt.Substring(pos2,len2-pos2);
			}
			pos2=strFolderExt.LastIndexOf("_");
			if(pos2>=0)
			{
				len2=strFolderExt.Length;
				strFolderExt=strFolderExt.Substring(pos2,len2-pos2);
			}

			//----?嚙緻嚙踝蕭WAAA.DOC韟的?嚙踝蕭嚙踝蕭GAAAO.DOC-------------

			string contentNameNoPath = RemoveWebPath(contentUrl);		//GD100100101.htm
			string contentNameNoExtension = RemoveExtension(contentNameNoPath);	//GD100100101

			string fileNameNoPath = RemoveLocalPath(localPathName);		// 043.gif
			//string fileNameNoExtension = RemoveExtension(fileNameNoPath);	//043

			string siteName = @"/sites/" + SPSHelper.GetSiteName;
			string folderUrl = @siteUrl + "/Shared%20Documents/" + deptCode;
			string destFolderName = "";
			
			SPWeb site = null;
			try
			{
				site = new SPSite(strServerURL).AllWebs[siteName];
				//嚙踝蕭嚙踝蕭穛鳴蕭嚙踝蕭訄嚙褓恬蕭嚙?
				site.AllowUnsafeUpdates=true;

				//--?嚙諍伐蕭嚙?撌踝蕭嚙?---------------------------------
				destFolderName = contentNameNoExtension + "-files";

				string folder = "Shared%20Documents/" + deptCode + "/" + destFolderName;

				SPFolder newFolder = site.GetFolder(folder);
				if (!newFolder.Exists)
				{
					if(newFolder.ParentFolder.Exists) 
					{
						SPFolderCollection folders = newFolder.ParentFolder.SubFolders;
						newFolder = folders.Add(folder);
						//newFolder = newFolder.ParentFolder..Add(folder);
					}
					//newFolder = site.Folders["Shared%20Documents"].SubFolders[deptCode].SubFolders.Add(destFolderName);
				}
				
				//if(!newFolder.Exists) return "";
				//http://localhost/sites/KMS/Shared%20Documents/03/CollectKnowledgeStep4_files/km1_p_01.gif
				string pathName = folder + "/" + fileNameNoPath;

				//--------------------------------------------------------------
				//Encoding encode = System.Text.Encoding.Default; 
				//StreamReader readStream = new StreamReader(InputFileStream,encode);
					
				//string str = readStream.ReadToEnd();

				//byte[] bytes = System.Text.Encoding.Default.GetBytes(str);

				//----Os颿戎嚙踝蕭?撌踝蕭嚙?-------------------------------------
				SPFile addedFile = newFolder.Files.Add(pathName,ConvertToStream(InputFileStream),true);
				if(addedFile != null) return addedFile.ServerRelativeUrl;
				else return "";	
				
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return "";
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
				
		}


		/// <summary>
		/// 
		/// </summary>
		/// <param name="SiteName"></param>
		/// <param name="FileUrl"></param>
		/// <param name="contents"></param>
		/// <param name="strFilename"></param>
		/// <returns></returns>
		public bool FileAdd(string SiteName,string FileUrl,byte[] contents,ref string strFilename)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			try
			{
				SPWeb myweb=null;
				SPFile upTextFile=null;
				myweb = new SPSite(strServerURL).AllWebs[SiteName];
				//嚙踝蕭嚙踝蕭穛鳴蕭嚙踝蕭訄嚙褓恬蕭嚙?
				myweb.AllowUnsafeUpdates=true;

				upTextFile = myweb.Files.Add(FileUrl, contents,true);
				strFilename=upTextFile.ServerRelativeUrl;
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				wic.Undo();
				return false;
					
			}

		}

		/// <summary>
		/// b擐伐蕭嚙賢中嚙稼嚙皚嚙踝蕭顗熄W嚙編嚙踝蕭

		/// </summary>
		/// <param name="fileUrl">嚙踝蕭Url</param>
		/// <param name="contentUrl">顗漸嚙踝蕭慦摻rl</param>
		/// <param name="deptCode">嚙踝蕭嚙編X</param>
		public void ChangeHyperlinkInContent(string contentUrl,string deptCode)
		{
		
			System.Uri myURi=null;
			WebRequest req=null;
			WebResponse res=null;
			Stream inStream=null;
			SPSite portal=null;
			SPWeb site=null;
			try
			{
				portal = new SPSite(strServerURL);

				site = portal.AllWebs["/sites/" + SPSHelper.GetSiteName];
				site.AllowUnsafeUpdates=true;

				myURi = new System.Uri(this.strServerURL + contentUrl);
				req = WebRequest.Create(myURi);
				req.Method = "GET";
				req.Timeout = System.Threading.Timeout.Infinite;
				//req.Credentials = CredentialCache.DefaultCredentials;
				CredentialCache myCache = new CredentialCache();

				myCache.Add(myURi,"NTLM",new NetworkCredential(SPSHelper.GetSpsUid,SPSHelper.GetSpsPwd,SPSHelper.GetDomainName));
			
				WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();

				req.Credentials = myCache;

				res = req.GetResponse();
				inStream = res.GetResponseStream();
					
				//----嚙?html嚙踝蕭韝云嚙?嚙踝蕭嚙窮嚙罷嚙?------------------------------
					
				Encoding encode = System.Text.Encoding.Default;
				StreamReader readStream = new StreamReader(inStream,encode);
					
				string str = readStream.ReadToEnd();

				//---?堸嚙踝蕭wURL?-----------------------------------------
				Regex r;
				Match m;

				r=new Regex("<div id=\"hgAttach\">.*</div>",RegexOptions.IgnoreCase);
				
				m=r.Match(str);

				if(m.Success)
				{
					str = str.Replace(m.Value,"");
				}

				//--K嚙稼?嚙踝蕭-------------------------------------------------------
				string contentUrlPath = RemoveName(contentUrl);
				string contentNameNoExtension = RemoveExtension(RemoveWebPath(contentUrl));

				string attachFolderUrl = contentUrlPath + "/" + contentNameNoExtension; //嚙踝蕭顗漸媬a}

				if (site.GetFolder("Shared%20Documents/" + deptCode + "/" + contentNameNoExtension).Exists)
				{
					string strAttach="<div id=\"hgAttach\">";
					SPFileCollection strFolderFiles=site.GetFolder("Shared%20Documents/" + deptCode + "/" + contentNameNoExtension).Files;
					int i=1;
					foreach(SPFile myfile in strFolderFiles)
					{
						//strAttach += "<b>嚙踝蕭" + Convert.ToString(i) + "G</b>&nbsp;" + 
						//	"<a href=\"/KMSWeb/KnowledgeManage/DownloadFile.aspx?FileType=2&FileUrl=" + 
						//	myfile.ServerRelativeUrl+"\" target=\"_blank\">" + myfile.Name + "</a><br>";
						strAttach += "<b>嚙踝蕭" + Convert.ToString(i) + "G</b>&nbsp;" + 
							"<a href=\"" + this.strServerURL + 
							myfile.ServerRelativeUrl+"\" target=\"_blank\">" + myfile.Name + "</a><br>";
						i++;
					}

					strAttach += "</div>";

					//M鞳揮</head>A銦以嚙皺嚙瞇嚙踝蕭r嚙褐匠窶加嚙?/head>嚙賦面嚙瘠


					r=new Regex("</head>",RegexOptions.IgnoreCase);
					m=r.Match(str);
					
					if(m.Success)
					{
						str = str.Replace(m.Value, m.Value + strAttach);
					}
				}

				//--嚙?嚙緝嚙??--------------------------------------------
				Regex r1;
				Match m1;
				r1=new Regex("<meta http-equiv=Content-Type.*>",RegexOptions.IgnoreCase);
			
				m1=r1.Match(str);
					
				string kkkk="<meta http-equiv=Content-Type content=\"text/html; charset=big5\">";

				if(m1.Success)
				{
					str = str.Replace(m1.Value,kkkk);
				}
				//------------------------------------------------------

				byte[] bytes = System.Text.Encoding.Default.GetBytes(str);
					
				MemoryStream stream = new MemoryStream(bytes);
				long length =  stream.Length;
				//-----------------------------------------------------------
					
				byte[] contents = new byte[length];
				int readnum;
				int num;
				readnum=0;

				while (readnum<length)
				{
					num= stream.Read(contents, readnum, (int) (length- readnum));//---modiby :inStream->stream
					readnum += num;
				}

				//聾W?嚙踝蕭嚙?
				if (site.GetFile(contentUrl).Exists)
				{
					DeleteFile(contentUrl);
				}
				site.Files.Add(contentUrl, contents,true);
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return;
			}
			finally
			{
				myURi=null;
				req=null;
				res=null;
				if (inStream!=null)
					inStream.Close();
				if (portal!=null)
					portal.Close();
				if (site!=null)
					site.Close();
			}
		}
	

		#endregion 慦踝蕭嚙踝蕭W嚙褒?]憛伐蕭嚙?嚙赭源/嚙踝蕭^

		#region DownloadFile
		/// <summary>
		/// 从WSS下载文件并使用当前的客户端线程打开.
		/// </summary>
		/// <param name="strFileSiteUrl">文件在WSS站点上的绝对路径如:sites/sz/Shared%20Documents/yyy.doc</param>
		/// <returns></returns>
		public bool DownloadFile(string strFileSiteUrl)
		{
			byte[] buffer = new Byte[BUFFERSIZE];
			long dataToRead;
			int length;
			System.Uri myURi;
			WebRequest req;
			WebResponse res;
				
			Stream inStream=null;
			
			string strNewUrl1=this.strServerURL + strFileSiteUrl;
			int index = strFileSiteUrl.LastIndexOf("/");
			int len = strFileSiteUrl.Length;
			string strSiteName = strFileSiteUrl.Substring(0,index);
			string strFileName = strFileSiteUrl.Substring(index+1,len-index-1);//aaaaa.doc
			try
			{
				myURi = new System.Uri(strNewUrl1);
				req = WebRequest.Create(myURi);
			
				req.Method = "GET";
				req.Timeout = System.Threading.Timeout.Infinite;
	
				req.Credentials = CredentialCache.DefaultCredentials;

				CredentialCache myCache = new CredentialCache();

				myCache.Add(myURi,"NTLM",new NetworkCredential(SPSHelper.GetSpsUid,SPSHelper.GetSpsPwd,SPSHelper.GetDomainName));
			
				WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();

				req.Credentials = myCache;

				res = req.GetResponse();
				inStream = res.GetResponseStream();	
					
				dataToRead = res.ContentLength;

				HttpContext.Current.Response.ContentType = "application/octet-stream";
				HttpContext.Current.Response.Charset = "utf-8";
				HttpContext.Current.Response.AddHeader("Content-Disposition","online;filename="+HttpUtility.UrlEncode(strFileName,System.Text.Encoding.GetEncoding("utf-8")));

				// Read the bytes.
				while (dataToRead > 0)
				{
					// Verify that the client is connected.
					if (HttpContext.Current.Response.IsClientConnected) 
					{
						// Read the data in buffer.
						length = inStream.Read(buffer, 0, 10000);
		
						// Write the data to the current output stream.
						HttpContext.Current.Response.OutputStream.Write(buffer, 0, length);
		
						// Flush the data to the HTML output.
						HttpContext.Current.Response.Flush();
		
						buffer= new Byte[BUFFERSIZE];
						dataToRead = dataToRead - length;
					}
					else
					{
						//prevent infinite loop if user disconnects
						dataToRead = -1;
					}
				}
				HttpContext.Current.Response.End();
				wic.Undo();
				return true;
					
			}
			catch(System.Threading.ThreadAbortException msg)
			{	
				errStr=msg.Message.ToString();
				msg=null;
				return true;
			}
//			catch(Exception ex)
//			{
//				errStr=ex.Message.ToString();
//				return false;
//			}
			finally
			{
				buffer=null;
				myURi=null;
				req=null;
				res=null;
				if(inStream!=null)
					inStream.Close();
				
			}
			
		}

		/// <summary>
		/// 以二进制方式读取指定Url地址的文件.
		/// </summary>
		/// <param name="fileUrl">文件的绝对Web地址,如:sites/abc/1/xxx.doc</param>
		/// <returns>二进制的字节数组</returns>
		public byte[] OpenBinary(string serverRelativeUrl)
		{
			long dataToRead;
			System.Uri myURi;
			WebRequest req;
			WebResponse res;
			Stream inStream = null;

			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();

			string strNewUrl1=this.strServerURL + serverRelativeUrl;
			int index = serverRelativeUrl.LastIndexOf("/");
			int len = serverRelativeUrl.Length;
			string strSiteName = serverRelativeUrl.Substring(0,index);
			string strFileName = serverRelativeUrl.Substring(index + 1,len - index - 1);//aaaaa.doc
			try
			{
				myURi = new System.Uri(strNewUrl1);
				req = WebRequest.Create(myURi);
				req.Method = "GET";
				req.Timeout = System.Threading.Timeout.Infinite;

				req.Credentials = CredentialCache.DefaultCredentials;
				//CredentialCache myCache = new CredentialCache();

				//myCache.Add(myURi,"NTLM",new NetworkCredential(SPSHelper.GetSpsUid,SPSHelper.GetSpsPwd,SPSHelper.GetDomainName));
				int offset = 0;
				res = req.GetResponse();
				inStream = res.GetResponseStream();

				//文件内容
				dataToRead = res.ContentLength;
				byte[] content = new byte[dataToRead];

				//从流读入内存中

				while (dataToRead > 0)
				{
					int byteReaded = 0;
					//当长度大于缓冲长度时,最多读取缓冲的长度
					if(dataToRead > BUFFERSIZE)
						byteReaded = inStream.Read(content,offset,BUFFERSIZE);
					else//只读取适合dataToRead的长度,避免指针过界
						byteReaded = inStream.Read(content,offset,(int)dataToRead);
					
					//减少剩余的字节数
					dataToRead = dataToRead - byteReaded;
					//增加偏移量

					offset += byteReaded;
				}
				return content;					
			}
			catch(System.Threading.ThreadAbortException msg)
			{	
				errStr=msg.Message.ToString();
				msg=null;
				return new byte[0];
			}
			finally
			{
				myURi=null;
				if(inStream != null)
					inStream.Close();
				req = null;
				res = null;
				wic.Undo();

			}			
		}

		/// <summary>
		/// 返回指定版本的文件的内容(以二进制数组).
		/// </summary>
		/// <param name="fileUrl">文件的相对Web地址,如:/abc/1/xxx.doc</param>
		/// <returns>二进制的字节数组</returns>
		public byte[] OpenBinary(string url,int version)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;
			SPFile upTextFile = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//----嚙踝蕭嚙衛選蕭site嚙編hared document警嚙踝蕭嚙踝蕭--------------------------
				SPWeb web=new SPSite(strServerURL).OpenWeb(Site);
				web.AllowUnsafeUpdates = true;

				upTextFile = web.GetFile(url);
				SPFileVersion fileVersion = null;//upTextFile.Versions[version];
				foreach(SPFileVersion ver in upTextFile.Versions)
				{
					if(ver.ID == version)
					{
						fileVersion = ver;
						break;
					}
				}
				byte[] bytes = fileVersion.OpenBinary();//upTextFile.Versions[version].OpenBinary();

				return bytes;
			}
			finally
			{
				if(site!=null)
					site.Close();
				upTextFile=null;
				wic.Undo();
			}
		}


		#endregion DownloadFile

		#region 目录维护
		/// <summary>
		/// 返回文档库的根目录

		/// </summary>
		/// <param name="docLibName">根目录</param>
		/// <returns></returns>
		public SPFolder GetRootFolderOfDocLib(string docLibName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			//SPFolderCollection srcFolders = null;
			SPWeb web = null;
			SPDocumentLibrary myDocLib = null;
			try
			{
				string strSiteName = @"/sites/" + SPSHelper.GetSiteName;
				web = new SPSite(strServerURL).AllWebs[strSiteName];
				web.AllowUnsafeUpdates = true;

				myDocLib = (SPDocumentLibrary)web.Lists[docLibName];
				return myDocLib.RootFolder;
			}
			finally
			{
				web = null;
				wic.Undo();
			}
		}

		/// <summary>
		/// 在WSS站点中创建目录,WSS站点名称自动从Web.Config中取得

		/// </summary>
		/// <param name="parentDirName">父目录URL地址</param>
		/// <param name="strDirName">目录名称</param>
		public SPFolder CreateFolder(string parentDirName,string strDirName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPFolderCollection srcFolders=null;
			SPWeb web=null;
			SPFolder newFolder = null;

			string strSiteName = @"/sites/"+SPSHelper.GetSiteName;
			try
			{
				web = new SPSite(strServerURL).AllWebs[strSiteName];
				web.AllowUnsafeUpdates = true;

				if(parentDirName == "") //创建一个文档库
				{
					newFolder = this.CreateDocLib(strDirName);
				}
				else
				{
					//将要创建的目录URL
					string destFolderName = parentDirName + "/" + strDirName;

					//判断目录是否已存在

					newFolder = web.GetFolder(destFolderName);

					//用加任意数字的方式,一直到目录不存在为此
					while(newFolder.Exists)
					{
						strDirName += new System.Random().Next(1,50).ToString();
						newFolder = web.GetFolder(parentDirName + "/" + strDirName);
					}

					//加入成为子目录

					srcFolders = web.GetFolder(parentDirName).SubFolders;

					newFolder = srcFolders.Add(strDirName);

				}
			}
			finally
			{
				web = null;
				wic.Undo();
			}
			return newFolder;

		}

		/// <summary>
		/// 更改目录
		/// </summary>
		/// <param name="strUrl">目录Url地址</param>
		/// <param name="newName">新名称</param>
		public SPFolder ChangeFolder(string strUrl,string newName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			//SPFolderCollection srcFolders = null;
			SPWeb web = null;
			SPDocumentLibrary myDocLib = null;
			SPDocumentLibrary newDocLib = null;
			SPFolder folder = null;
			try
			{
				string strSiteName = @"/sites/" + SPSHelper.GetSiteName;
				web = new SPSite(strServerURL).AllWebs[strSiteName];
				web.AllowUnsafeUpdates = true;

				folder = web.GetFolder(strUrl);
				if(!folder.Exists) throw new Exception("目录不存在！");

				if(folder.ParentFolder.ServerRelativeUrl == strSiteName + "/") //改变文档库名称

				{
					myDocLib = (SPDocumentLibrary)web.Lists[folder.ContainingDocumentLibrary];

					try
					{
						newDocLib = (SPDocumentLibrary)web.Lists[newName];
					}
					catch //发生异常表示没有此文档库
					{
						newDocLib = null;
					}

					//用加数字的方式,一直到文档库不存在为止
					int i = 0;
					while(newDocLib != null)
					{
						newName += i.ToString();
						try
						{
							newDocLib = (SPDocumentLibrary)web.Lists[newName];
						}
						catch //发生异常时说明还没有
						{
							newDocLib = null;
						}
						i ++;
					}

					myDocLib.Title = newName;
					myDocLib.Update();

					folder = myDocLib.RootFolder;
					goto Exit;
				}
				else if(folder.Exists) 
				{
					folder.MoveTo(folder.ServerRelativeUrl.
						Substring(0,folder.ServerRelativeUrl.LastIndexOf("/")) + "/" + newName);
					
					goto Exit;
				}

			Exit:
				return folder;
			}
			finally
			{
				web = null;
				wic.Undo();
			}					
		}

		/// <summary>
		/// 移动目录
		/// </summary>
		/// <param name="strUrl">被移动目录在wss上的路径</param>
		/// <param name="newstrUrl">目标在wss上的路径</param>
		/// <returns>SPFolder</returns>
		public SPFolder MoveFolder(string strUrl,string newstrUrl)
		{
			WindowsImpersonationContext wic = CreateIdentity(SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			Microsoft.SharePoint.SPWeb web = null ;
			try
			{　　
				string strSiteName = @"/sites/" + SPSHelper.GetSiteName;
				web = new SPSite(strServerURL).AllWebs[strSiteName];
				web.AllowUnsafeUpdates = true;
				SPFolder bemovedFolder = web.GetFolder(strUrl);	
				//判断是否根目录(表示一个文档库)

				if(bemovedFolder.ParentFolder.ServerRelativeUrl == strSiteName + "/") 
					return bemovedFolder; //文档库无法移动,直接返回文档库的根目录

				
				newstrUrl = newstrUrl +  @"/" + bemovedFolder.Name;
				SPFolder folder = web.GetFolder(newstrUrl);
				while(folder.Exists)
				{   
					newstrUrl += new System.Random().Next(1,50).ToString();
					folder = web.GetFolder(newstrUrl);
				}

				bemovedFolder.MoveTo(newstrUrl);
				web.Folders.Delete(bemovedFolder.Url);

				return bemovedFolder;
			}		
			finally
			{
				web = null;
				wic.Undo();
			}
		}
		
		#endregion CreateFolder

		#region [文档库维护]

		/// <summary>
		/// 创建一个文档库(根目录)
		/// </summary>
		/// <param name="strDocLibName">新文档库的名称(Title)</param>
		/// <returns>文档库所在的根目录</returns>
		public SPFolder CreateDocLib(string strDocLibName)
		{
			SPGlobalAdmin globAdmin=null;
			System.Uri uri=null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			SPDocumentLibrary myDocLib = null;
			
			string strSiteUrl = strServerURL + "/sites/" + SPSHelper.GetSiteName;
			string Domain=strDomainName+@"\administrator";
			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
				
				//
				SPWeb web = new SPSite(strServerURL).OpenWeb("sites/" + SPSHelper.GetSiteName);

				web.AllowUnsafeUpdates = true;

				System.Guid newId;
				//检测是否存在

				try
				{
					myDocLib = (SPDocumentLibrary)web.Lists[strDocLibName];
				}
				catch //发生异常时说明还没有
				{

				}

				if(myDocLib == null)
					newId = web.Lists.Add(strDocLibName,"",SPListTemplateType.DocumentLibrary);
				else
				{
					//用加任意数字的方式,一直到文档库不存在为止
					while(myDocLib != null)
					{
						strDocLibName += new System.Random().Next(1,50).ToString();
						try
						{
							myDocLib = (SPDocumentLibrary)web.Lists[strDocLibName];
						}
						catch //发生异常时说明还没有
						{
							myDocLib = null;
						}
					}
					newId = web.Lists.Add(strDocLibName,"",SPListTemplateType.DocumentLibrary);
				}
				myDocLib = (SPDocumentLibrary)web.Lists[newId];
				//允许版本!默认是不开启版本的.
				myDocLib.EnableVersioning = true;
				myDocLib.Update();
				//移除读者的权限!
				SPMember member = web.Roles.GetSpecialRole(SPRoleType.Reader);
				myDocLib.Permissions.Remove(member);
				member = web.Roles.GetSpecialRole(SPRoleType.WebDesigner);
				if(member != null) myDocLib.Permissions.Remove(member);
				member = web.Roles.GetSpecialRole(SPRoleType.Contributor);
                if(member != null) myDocLib.Permissions.Remove(member);
				
				//加入一个自定义字段(做为标识和检索时的标识符)
				myDocLib.Fields.Add("DocId",SPFieldType.Text,false);
				return  myDocLib.RootFolder;;
			}
			finally
			{
				globAdmin=null;
				uri=null;
				virtualServer=null;
				siteCollections=null;

			}

		}

		/// <summary>
		/// 删除文档库

		/// </summary>
		/// <param name="strSiteName">站点名称</param>
		/// <param name="strDocLibName">文档库名称</param>
		/// <returns></returns>
		public bool DeleteDocLib(string strSiteName,string strDocLibName)
		{
			SPGlobalAdmin globAdmin=null;
			System.Uri uri=null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			SPListCollection lists = null;

			string strSiteUrl = strServerURL + "/sites/" + strSiteName;
			string Domain=strDomainName+@"\administrator";
			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
					
				//----嚙踝蕭嚙衛選蕭site嚙編hared document警嚙踝蕭嚙踝蕭--------------------------
				SPWeb web=new SPSite(strServerURL).OpenWeb("sites/"+strSiteName);
				web.AllowUnsafeUpdates = true;

				web.Lists.Delete(web.Lists[strDocLibName].ID);
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				globAdmin=null;
				uri=null;
				virtualServer=null;
				siteCollections=null;

			}

		}

		/// <summary>
		/// 修改文档库标题

		/// </summary>
		/// <param name="strSiteName"></param>
		/// <param name="strDocLibName"></param>
		/// <param name="newTitle"></param>
		/// <returns></returns>
		public bool ChangeDocLibTitle(string strSiteName,string strDocLibName,string newTitle)
		{
			SPGlobalAdmin globAdmin=null;
			System.Uri uri=null;
			SPDocumentLibrary myDocLib = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			SPListCollection lists = null;

			string strSiteUrl = strServerURL + "/sites/" + strSiteName;
			string Domain=strDomainName+@"\administrator";
			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
					
				//----嚙踝蕭嚙衛選蕭site嚙編hared document警嚙踝蕭嚙踝蕭--------------------------
				SPWeb web=new SPSite(strServerURL).OpenWeb("sites/"+strSiteName);
				web.AllowUnsafeUpdates = true;

				myDocLib = (SPDocumentLibrary)web.Lists[strDocLibName];
				myDocLib.Title = newTitle;
				myDocLib.Update();
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				globAdmin=null;
				uri=null;
				virtualServer=null;
				siteCollections=null;

			}

		}


		#endregion
		
		#region AddUrlToText

		public void AddUrlToText(string SiteName)
		{
			System.Uri myURi;
			WebRequest req;
			WebResponse res;
			Stream inStream=null;

			string strSiteName="sites/"+SiteName;
			SPWeb web = new SPSite(strServerURL).AllWebs[strSiteName];
			web.AllowUnsafeUpdates=true;
			SPFolderCollection myFolder=web.GetFolder("Shared%20Documents").SubFolders;
			SPFileCollection myFile=web.GetFolder("Shared%20Documents").Files;
			string strNewUrl="";
			foreach(SPFolder folder1 in myFolder)
			{
				string strNewUrl1=this.strServerURL+"/sites/"+SiteName+"/Shared%20Documents/"+folder1.Name+".htm";
				strNewUrl=strNewUrl1;
				string fileName=folder1.Name+".htm";
				if(folder1.Name!="Forms")
				{				
					if(web.GetFolder("Shared%20Documents/"+fileName).Exists)
					{
						myURi = new System.Uri(strNewUrl1);
					}
					else
					{
						string strNewUrl2=this.strServerURL+"/sites/"+SiteName+"/Shared%20Documents/"+folder1.Name+".html";
						fileName=folder1.Name+".html";
						myURi = new System.Uri(strNewUrl2);
						strNewUrl=strNewUrl2;
					}
					
					//------------------------------------------------------------------------------------------------
				
					req = WebRequest.Create(myURi);
			
					req.Method = "GET";
					req.Timeout = System.Threading.Timeout.Infinite;
	
					//req.Credentials = CredentialCache.DefaultCredentials;

					CredentialCache myCache = new CredentialCache();

					myCache.Add(myURi,"NTLM",new NetworkCredential(SPSHelper.GetSpsUid,SPSHelper.GetSpsPwd,SPSHelper.GetDomainName));
			
					WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();

					req.Credentials = myCache;

					res = req.GetResponse();
					inStream = res.GetResponseStream();	
					//dataToRead = res.ContentLength;
					Encoding encode = System.Text.Encoding.Default;
					StreamReader readStream = new StreamReader( inStream,encode);

					string str=readStream.ReadToEnd();
				
					string strAttach="<div id=\"unicom\">";
					SPFileCollection strFolderFiles=web.GetFolder("Shared%20Documents/"+folder1.Name).Files;
					int i=1;
					foreach(SPFile myfile in strFolderFiles)
					{
						strAttach+="<b>譫嚙踝蕭"+Convert.ToString(i)+"</b>&nbsp;<a href=\""+strServerURL+myfile.ServerRelativeUrl+"\"  target=\"_blank\">"+myfile.Name+"</a><br>";
						i++;
					}
					strAttach=strAttach+"</div>";
					Regex r;
					Match m;
					r=new Regex("</head>",RegexOptions.IgnoreCase);
			
					m=r.Match(str);
					
					if(m.Success)
					{
						str = str.Replace(m.Value,m.Value+strAttach);
					}

					byte[] bytes = System.Text.Encoding.Default.GetBytes(str);
					
					MemoryStream stream = new MemoryStream(bytes);
					long length =  stream.Length;
					//-----------------------------------------------------------
					



					byte[] contents = new byte[length];
					int readnum;
					int num;
					readnum=0;

					while (readnum<length)
					{
						num= stream.Read(contents, readnum, (int) (length- readnum));//---modiby :inStream->stream
						readnum += num;
					}
					web.Files.Add(strNewUrl, contents,true);
				}
				//---------------------------
			}

		}

		
		#endregion AddUrlToText

		#region SaveText
		/// <summary>
		/// 嚙踝蕭嚙踝蕭葑鉏哨蕭嚙踝蕭嚙踝蕭覺嚙踝蕭

		/// </summary>
		/// <param name="strSiteName">TeamSite嚙調橘蕭		GZ</param>
		/// <param name="strFileName">嚙踝蕭嚙踝蕭嚙踝蕭躁嚙踝蕭		GZD1001011.htm</param>
		/// <param name="strContent">嚙踝蕭嚙踝蕭警嚙踝蕭嚙踝蕭嚙踝蕭硊	</param>
		/// <returns></returns>
		public bool  SaveText(string strSiteName,string strFileName,string strContent)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
				
			SPWeb site=null;
			MemoryStream stream=null;
			//嚙踝蕭炴嚙踝蕭嚙踝蕭嚙踝蕭警嚙踝蕭URL
			string strNewUrl1="";

			
			string LstrFileName=strFileName;
			
			string LstrSiteName=strSiteName;
				
			string Site=@"/sites/"+LstrSiteName;
			string strSiteUrl=@Site+"/Shared%20Documents";
			try
			{

				site = new SPSite(strServerURL).AllWebs[LstrSiteName];
					
				//嚙踝蕭嚙踝蕭穛鳴蕭嚙踝蕭訄嚙褓恬蕭嚙?
				site.AllowUnsafeUpdates=true;
					
				//嚙踝蕭嚙踝蕭警URL
				strNewUrl1=strServerURL+strSiteUrl+"/"+LstrFileName;
					
				//襤嚙踝蕭硊嚙論迎蕭嚙踝蕭嚙踝蕭

				byte[] bytes = System.Text.Encoding.Default.GetBytes(strContent);
				stream = new MemoryStream(bytes);

				if (!WebDav(strNewUrl1,stream))
					return false;
				else
					return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
				stream.Close();
			}
		}
		#endregion SaveText
	
		#region 身份模拟和替换


		public static WindowsIdentity CreateIdentity(string User, string Domain, string Password)
		{
			// The Windows NT user token.
			IntPtr tokenHandle = new IntPtr(0);

			const int LOGON32_PROVIDER_DEFAULT = 0;
			const int LOGON32_LOGON_NETWORK = 3;

			tokenHandle = IntPtr.Zero;

			// Call LogonUser to obtain a handle to an access token.
			bool returnValue = LogonUser(User, Domain, Password, 
				LOGON32_LOGON_NETWORK, LOGON32_PROVIDER_DEFAULT,
				ref tokenHandle);

			if (false == returnValue)
			{
				int ret = Marshal.GetLastWin32Error();
				throw new Exception("LogonUser failed with error code: " +  ret);
			}

			System.Diagnostics.Debug.WriteLine("Created user token: " + tokenHandle);

			//The WindowsIdentity class makes a new copy of the token.
			//It also handles calling CloseHandle for the copy.
			WindowsIdentity id = new WindowsIdentity(tokenHandle);
			CloseHandle(tokenHandle);
			return id;
		}
		[DllImport("advapi32.dll", SetLastError=true)]
		private static extern bool LogonUser(String lpszUsername, String lpszDomain, String lpszPassword,
			int dwLogonType, int dwLogonProvider, ref IntPtr phToken);

		[DllImport("kernel32.dll", CharSet=CharSet.Auto)]
		private extern static bool CloseHandle(IntPtr handle);

		#endregion 嚙踝蕭嚙踝蕭瑊z嚙踝蕭峇

		#region [订阅目录或文档]
		public void Subscribe(string url,SPEventType eventType,SPAlertFrequency frequency,string userName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			//SPUser user = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//打开站点.
				SPWeb web = new SPSite(strServerURL).OpenWeb(Site);
				web.AllowUnsafeUpdates = true;	
		
				//需要订阅的用户名称.
				//user = web.CurrentUser;//web.Users[userName];
				//user = web.Users[SPSHelper.GetDomainName + "\\" + userName];
				//2月21日更改。

				SPUserCollection users = web.Users.GetCollection(new string[]{SPSHelper.GetDomainName + "\\" + userName});
				
				//没找到用户则返回
				if(users.Count <= 0) return;

				SPFolder folder = web.GetFolder(url);
				if(folder.Exists) //订阅目录
				{
					SubscribeFolder(web,folder,eventType,frequency,users[0]);
				}
				else //订阅文件
				{
					SPFile file = web.GetFile(url);
					if(file.Exists)
					{
						SubscribeFile(web,file,eventType,frequency,users[0]);
					}
				}
			}
			catch(SPException se)
			{
				errStr = se.ErrorCode.ToString();
				errStr += se.Message;
				throw se;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
		}

		/// <summary>
		/// 订阅目录(或文档库)
		/// </summary>
		/// <param name="web"></param>
		/// <param name="folder"></param>
		/// <param name="eventType"></param>
		/// <param name="frequency"></param>
		/// <param name="user"></param>
		protected void SubscribeFolder(SPWeb web,SPFolder folder,SPEventType eventType,
			SPAlertFrequency frequency,SPUser user)
		{
			SPDocumentLibrary myDocLib = (SPDocumentLibrary)web.Lists[folder.ContainingDocumentLibrary];
			SPListItemCollection items = null;
			string Site = @"/sites/" + SPSHelper.GetSiteName;
			if(folder.ParentFolder.ServerRelativeUrl == Site + "/") //订阅文档库

			{
				user.Alerts.Add((SPList)myDocLib,eventType,frequency);
			}
			else //订阅目录
			{
				items = myDocLib.GetItemsInFolder(myDocLib.DefaultView,folder.ParentFolder);
				foreach(SPListItem item in items)
				{	
					if(item["URL 路径"].ToString().ToLower() == folder.ServerRelativeUrl.ToLower())
					{
						user.Alerts.Add(item,eventType,frequency);
						break;
					}
				}
			}			
		}

		/// <summary>
		/// 订阅文件
		/// </summary>
		/// <param name="file">需要订阅的文件</param>
		/// <param name="eventType">订阅类型(新增/编辑/删除)</param>
		/// <param name="frequency">发生频率(立即/每日/每周)</param>
		/// <param name="user">需要订阅的用户</param>
		protected void SubscribeFile(SPWeb web,SPFile file,SPEventType eventType,
			SPAlertFrequency frequency,SPUser user)
		{
			SPDocumentLibrary myDocLib = (SPDocumentLibrary)web.Lists[file.ParentFolder.ContainingDocumentLibrary];
			SPListItemCollection items = null;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			items = myDocLib.GetItemsInFolder(myDocLib.DefaultView,file.ParentFolder);
			foreach(SPListItem item in items)
			{	
				if(item["URL 路径"].ToString().ToLower() == file.ServerRelativeUrl.ToLower())
				{
					user.Alerts.Add(item,eventType,frequency);
					break;
				}
			}			
		}

		/// <summary>
		/// 返回用户在当前站点中的所有订阅集合

		/// </summary>
		/// <param name="userName">用户NT名称</param>
		/// <returns>表示订阅集合的SPAlertCollection类型</returns>
		public SPAlertCollection GetAlerts(string userName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			SPUser user = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//打开站点.
				SPWeb web = new SPSite(strServerURL).OpenWeb(Site);
				
				//需要订阅的用户名称.
				//user = web.CurrentUser;//web.Users[userName];
				user = web.AllUsers[SPSHelper.GetDomainName + "\\" + userName];
				return user.Alerts;
			}
			catch(SPException se)
			{
				errStr = se.ErrorCode.ToString();
				errStr += se.Message;
				throw se;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
		}

		/// <summary>
		/// 删除一个或多个订阅
		/// </summary>
		/// <param name="userName">用户NT登录名称</param>
		/// <param name="alerts">包含待删除订阅GUID的集合</param>
		public void DeleteAlerts(string userName,ArrayList delAlerts)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();

			SPWeb site = null;
			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			SPUser user = null;
			SPAlertCollection collection1 = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;
				
			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//打开站点.
				site = new SPSite(strServerURL).OpenWeb(Site);
				site.AllowUnsafeUpdates = true;				
				//需要订阅的用户名称.
				user = site.AllUsers[SPSHelper.GetDomainName + "\\" + userName];
				collection1 = user.Alerts;

				foreach(System.Guid guid in delAlerts)
				{
					collection1.Delete(guid);
				}
			}
			catch(SPException se)
			{
				errStr = se.ErrorCode.ToString();
				errStr += se.Message;
				throw se;
			}
			finally
			{
				if(site != null)
					site.Close();
				wic.Undo();
				globAdmin=null;
				uri = null;
				virtualServer = null;
				siteCollections = null;
				user = null;
				collection1 = null;
			}
		}


		/// <summary>
		/// 删除一个列表的所有订阅

		/// </summary>
		/// <param name="alerts">目录的地址(包括在列表中,如:文档库)</param>
		public void DeleteAlerts(string url)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();

			SPWeb site = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;
				
			try
			{
				//打开站点.
				site = new SPSite(strServerURL).OpenWeb(Site);
				site.AllowUnsafeUpdates = true;		
				//寻找目录和文档库
				SPFolder subscribed = site.GetFolder(url);

				//目录不存在,直接返回
				if(!subscribed.Exists) return;
				
				//取得文档库

				SPDocumentLibrary docLib = (SPDocumentLibrary)site.Lists[subscribed.ContainingDocumentLibrary];
				ArrayList list = new ArrayList();
				foreach(SPAlert alert in site.Alerts)
				{
					//如果订阅列表和待审核的目录是同一个列表,则删除这个订阅
                    
					if(alert.List.Title == docLib.Title)
					{   
						//ListItem itemID = new ListItem(alert.ID);
					    list.Add(alert.ID);	
					}					
				}
				foreach(System.Guid guid in list)
				{   
					string aa = guid.ToString();
					site.Alerts.Delete(guid);
				}

			}
			catch(SPException se)
			{
				errStr = se.ErrorCode.ToString();
				errStr += se.Message;
				throw se;
			}
			finally
			{
				if(site != null)
					site.Close();
				site = null;
				wic.Undo();
			}
		}
		#endregion 

		#region [用户操作]

		/// <summary>
		/// 返回指定NT登录名称的用户

		/// </summary>
		/// <param name="userName"></param>
		/// <returns></returns>
		public SPUser GetUser(string userName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			SPUser user = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//打开站点.
				SPWeb web = new SPSite(strServerURL).OpenWeb(Site);
				
				//需要订阅的用户名称.
				//user = web.CurrentUser;//web.Users[userName];
				user = web.AllUsers[SPSHelper.GetDomainName + "\\" + userName];
				return user;
			}
			catch(SPException se)
			{
				errStr = se.ErrorCode.ToString();
				errStr += se.Message;
				throw se;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
		}
			
		/// <summary>
		/// 更新用户信息
		/// </summary>
		/// <param name="userName">用户登陆名称</param>
		public void UpdateUser(string userName,string email)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb web = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			//SPUser user = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//打开站点.
				web = new SPSite(strServerURL).OpenWeb(Site);
				web.AllowUnsafeUpdates = true;
				//需要订阅的用户名称.
				//user = web.CurrentUser;//web.Users[userName];
				SPUserCollection users = web.Users.GetCollection(new string[]{SPSHelper.GetDomainName + "\\" + userName});
				//user = web.AllUsers[SPSHelper.GetDomainName + "\\" + userName];
				if(users.Count > 0)
				{
					foreach(SPUser user1 in users)
					{
						user1.Email = email;
						user1.Update();
					}
				}
			}
			catch(SPException se)
			{
				errStr = se.ErrorCode.ToString();
				errStr += se.Message;
				throw se;
			}
			finally
			{
				if(web!=null)
					web.Close();
				wic.Undo();
			}
		}
										   
		/// <summary>
		/// 返回用户在当前站点中的所有订阅集合

		/// </summary>
		/// <param name="userName">用户NT名称</param>
		/// <returns>表示订阅集合的SPAlertCollection类型</returns>
		public SPUserCollection GetUsers()
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
			SPWeb site = null;

			SPGlobalAdmin globAdmin=null;
			System.Uri uri = null;
			SPVirtualServer virtualServer = null;
			SPSiteCollection siteCollections = null;
			SPUser user = null;
			string SiteName = SPSHelper.GetSiteName;
			string Site = @"/sites/" + SPSHelper.GetSiteName;

			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
			
				//打开站点.
				SPWeb web = new SPSite(strServerURL).OpenWeb(Site);
				
				//需要订阅的用户名称.
				//user = web.CurrentUser;//web.Users[userName];
				//user = web.Users[SPSHelper.GetDomainName + "\\" + userName];
				return web.AllUsers;
			}
			catch(SPException se)
			{
				errStr = se.ErrorCode.ToString();
				errStr += se.Message;
				throw se;
			}
			finally
			{
				if(site!=null)
					site.Close();
				wic.Undo();
			}
		}

		#endregion

		#region CopyFileCrossSite
		/// <summary>
		/// 幘鳴蕭嚙踝蕭庥帤嚙踝蕭瞨穿蕭嚙踝蕭嚙誰羌塚蕭警嚙踝蕭譫嚙踝蕭
		/// </summary>
		/// <param name="strSourceSiteUrl">嚙諂湛蕭躁URL:		嚙踝蕭/sites/sz/shared Document/yyy.doc</param>
		/// <param name="strDescSiteUrl">嚙衝選蕭嚙踝蕭躁URL:		嚙踝蕭/sites/sz/shared Document/bbb.doc</param>
		/// <returns>true:嚙踝蕭尨嚙踝蕭嚙踝蕭嚙衝潘蕭伄嚙踝蕭嚙?false嚙踝蕭嚙踝蕭尨嚙踝蕭嚙踝蕭嚙衝潘蕭囮嚙?/returns>
		private bool CopyFileCrossSite(string strSourceFileUrl, string strDescSiteUrl)
		{
				
			string delimStr = "/";
			char [] delimiter = delimStr.ToCharArray();
			string [] split = null;

			string strNewUrl1=strServerURL+strDescSiteUrl;
			
			strSourceFileUrl=strServerURL+strSourceFileUrl;

			split=strDescSiteUrl.Split(delimiter);
			string strSite="/"+split[1]+"/"+split[2];

			string strFileName=split[4];

			System.Uri myURi=null;
			WebRequest req=null;
			WebResponse res=null;
			Stream inStream=null;
			SPSite portal=null;
			SPWeb site=null;
			try
			{
				myURi = new System.Uri(strSourceFileUrl);
				req = WebRequest.Create(myURi);
				req.Method = "GET";
				req.Timeout = System.Threading.Timeout.Infinite;
				//req.Credentials = CredentialCache.DefaultCredentials;

				CredentialCache myCache = new CredentialCache();

				myCache.Add(myURi,"NTLM",new NetworkCredential(SPSHelper.GetSpsUid,SPSHelper.GetSpsPwd,SPSHelper.GetDomainName));
			
				WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();

				req.Credentials = myCache;

				res = req.GetResponse();
				inStream = res.GetResponseStream();
				long length =  res.ContentLength;

				portal = new SPSite(strServerURL);
				site = portal.AllWebs[strSite];
				site.AllowUnsafeUpdates=true;

				byte[] contents = new byte[length];
				int readnum;
				int num;
				readnum=0;

				while (readnum<length)
				{
					num= inStream.Read(contents, readnum, (int) (length- readnum));//---modiby :inStream->stream
					readnum += num;
				}
					
				//嚙踝蕭炴嚙踝蕭嚙踝蕭
				if (site.GetFile(strNewUrl1).Exists)
				{
					DeleteFile(split[2],"Shared%20Documents",strFileName);
				}
				site.Files.Add(strNewUrl1, contents);
			}
				
			catch(Microsoft.SharePoint.SPException msg2)
			{
				errStr=msg2.Message.ToString();
				return false;
			}
			catch(System.UriFormatException)
			{
				errStr="88";
				return false;
			}
			catch(Exception msg1)
			{
				errStr=msg1.Message.ToString();
				return false;
			}
			finally
			{
				myURi=null;
				req=null;
				res=null;
				if (inStream!=null)
					inStream.Close();
				if (portal!=null)
					portal.Close();
				if (site!=null)
					site.Close();
			}
			return true;
		}
			
		/// <summary>
		/// 嚙踝蕭嚙踝蕭嚙誼湛蕭嚙踝蕭鞶狠嚙踝蕭嚙誰羌塚蕭警嚙踝蕭譫嚙踝蕭

		/// </summary>
		/// <param name="strSourceFileUrl"></param>
		/// <param name="strDescSiteUrl"></param>
		/// <param name="OldFolder"></param>
		/// <param name="NewFolder"></param>
		/// <param name="TextFileName">嚙踝蕭嚙踝蕭嚙踝蕭躁嚙踝蕭</param>
		/// <returns></returns>
		private bool CopyFileCrossSite(string strSourceFileUrl, string strDescSiteUrl,string OldFolder,string NewFolder,string TextFileName)
		{
				
			string delimStr = "/";
			char [] delimiter = delimStr.ToCharArray();
			string [] split = null;

			string strNewUrl1=strServerURL+strDescSiteUrl;
			
			strSourceFileUrl=strServerURL+strSourceFileUrl;

			split=strDescSiteUrl.Split(delimiter);
			string strSite="/"+split[1]+"/"+split[2];

			string strFileName=split[4];

			System.Uri myURi=null;
			WebRequest req=null;
			WebResponse res=null;
			Stream inStream=null;
			SPSite portal=null;
			SPWeb site=null;
			try
			{
				portal = new SPSite(strServerURL);
				site = portal.AllWebs[strSite];
				site.AllowUnsafeUpdates=true;

				myURi = new System.Uri(strSourceFileUrl);
				req = WebRequest.Create(myURi);
				req.Method = "GET";
				req.Timeout = System.Threading.Timeout.Infinite;
				//req.Credentials = CredentialCache.DefaultCredentials;
				CredentialCache myCache = new CredentialCache();

				myCache.Add(myURi,"NTLM",new NetworkCredential(SPSHelper.GetSpsUid,SPSHelper.GetSpsPwd,SPSHelper.GetDomainName));
			
				WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();

				req.Credentials = myCache;

				res = req.GetResponse();
				inStream = res.GetResponseStream();
				//long length =  res.ContentLength;
					

					
				//----嚙衝庾tml嚙踝蕭躁嚙踝蕭迮嚙踝蕭嚙諉蛛蕭硊醴翹------------------------------
					
				Encoding encode = System.Text.Encoding.Default;
				StreamReader readStream = new StreamReader(inStream,encode);
					
				string str=readStream.ReadToEnd();

				if((OldFolder!="")||(OldFolder.Length>0))
				{
					str = str.Replace(OldFolder,NewFolder);
				}
				//--嚙踝蕭嚙踝蕭嚙?------------------------------------------------------
				if (site.GetFolder("Shared%20Documents/"+TextFileName).Exists)
				{
					string strAttach="<div id=\"unicom\">";
					SPFileCollection strFolderFiles=site.GetFolder("Shared%20Documents/"+TextFileName).Files;
					int i=1;
					foreach(SPFile myfile in strFolderFiles)
					{
						strAttach+="<b>虒嚙踝蕭"+Convert.ToString(i)+"</b>&nbsp;<a href=\"/KMWebApp/KnowledgeManage/DownloadFile.aspx?FileType=2&FileUrl="+myfile.ServerRelativeUrl+"\"  target=\"_blank\">"+myfile.Name+"</a><br>";
						i++;
					}
					strAttach=strAttach+"</div>";
					Regex r;
					Match m;
					r=new Regex("</head>",RegexOptions.IgnoreCase);
			
					m=r.Match(str);
					
					if(m.Success)
					{
						str = str.Replace(m.Value,m.Value+strAttach);
					}
				}

				//--嚙踝蕭嚙踝蕭嚙賣遙--------------------------------------------
				//<meta http-equiv=Content-Type content="text/html; charset=us-ascii">

				Regex r1;
				Match m1;
				r1=new Regex("<meta http-equiv=Content-Type.*>",RegexOptions.IgnoreCase);
			
				m1=r1.Match(str);
					
				string kkkk="<meta http-equiv=Content-Type content=\"text/html; charset=gb2312\">";
				if(m1.Success)
				{
					str = str.Replace(m1.Value,kkkk);
				}
				//------------------------------------------------------

				byte[] bytes = System.Text.Encoding.Default.GetBytes(str);
					
				MemoryStream stream = new MemoryStream(bytes);
				long length =  stream.Length;
				//-----------------------------------------------------------
					



				byte[] contents = new byte[length];
				int readnum;
				int num;
				readnum=0;

				while (readnum<length)
				{
					num= stream.Read(contents, readnum, (int) (length- readnum));//---modiby :inStream->stream
					readnum += num;
				}
				//嚙誕湛蕭嚙踝蕭嚙?
				if (site.GetFile(strNewUrl1).Exists)
				{
					DeleteFile(split[2],"Shared%20Documents",strFileName);
				}
				site.Files.Add(strNewUrl1, contents,true);
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				myURi=null;
				req=null;
				res=null;
				if (inStream!=null)
					inStream.Close();
				if (portal!=null)
					portal.Close();
				if (site!=null)
					site.Close();
			}
			return true;
		}
			

		#endregion CopyFileCrossSite

		#region IsFolder
		/// <summary>
		/// 嚙踝蕭迠嚙踝蕭嚙踝蕭警嚙踝蕭嚙諂湛蕭躁嚙衝螞潘蕭嚙踝蕭嚙?
		/// </summary>
		/// <param name="PathStr">嚙踝蕭嚙踝蕭警嚙蝓瘀蕭嚙?/param>
		/// <param name="FolderName">嚙踝蕭嚙踝蕭硉嚙踝蕭嚙踝蕭嚙衝蛛蕭嚙踝蕭埭嚙衝潘蕭醴翹</param>
		/// <returns>嚙踝蕭嚙踝蕭嚙踝蕭嚙?/returns>
		private bool IsFolder(string PathStr,ref string FolderName,ref string FileFolderExtension)
		{
			string filename=System.IO.Path.GetFileNameWithoutExtension(PathStr);
			string filedir=System.IO.Path.GetDirectoryName(PathStr);

			string alldir1=filedir+"\\"+filename+"_files";
			string alldir2=filedir+"\\"+filename+".files";
			string alldir="";
			string dir="";
			
			//----嚙踝蕭迠嚙踝蕭警嚙衝螞潘蕭嚙踝蕭嚙?-----------------------------
			if ((!System.IO.Directory.Exists(alldir1))&&(!System.IO.Directory.Exists(alldir2)))
			{
				return false;
			}
			if (System.IO.Directory.Exists(alldir1))
			{
				dir=filename+"_files";
				alldir="_files";
			}
			if (System.IO.Directory.Exists(alldir2))
			{
				dir=filename+".files";
				alldir=".files";
			}
			FolderName=dir;
			FileFolderExtension=alldir;
			return true;
		}
		#endregion IsFolder

		#region ConvertToStream
		/// <summary>
		/// 痚嚙踝蕭警嚙論迎蕭嚙踝蕭嚙踝蕭嚙踝蕭宒

		/// </summary>
		/// <param name="strPath">嚙衝蛛蕭繚嚙踝蕭</param>
		/// <returns>嚙踝蕭嚙踝蕭嚙踝蕭嚙褊?/returns>
		private byte[] ConvertToStream(string strPath)
		{
			FileInfo fi=null;
			FileStream fStream=null;
			byte[] contents=null;
			try
			{
				//--籵嚙踝蕭嚙衝蛛蕭嚙踝蕭嚙踝蕭警嚙論迎蕭嚙踝蕭伅嚙踝蕭嚙複賂蕭宒嚙踝蕭嚙踝蕭嚙箱ontents嚙踝蕭

				fi=new FileInfo(strPath); 
				
				fStream=fi.OpenRead();
				contents = new byte[fStream.Length];
				fStream.Read(contents, 0, (int)fStream.Length);
				return contents;
			}
			catch
			{
				throw;
			}
			finally
			{
				fi=null;
				if(fStream!=null)
					fStream.Close();
			}
			
			//--------------------------------------------------
		}


		private byte[] ConvertToStream(Stream fStream)
		{
			byte[] contents=null;
			try
			{
				//--嚙談剁蕭嚙踝蕭警嚙踝蕭嚙踝蕭嚙衝蛛蕭蛌嚙踝蕭嚙褕塚蕭嚙踝蕭嚙褊踝蕭嚙踝蕭嚙踝蕭contents嚙踝蕭

				contents = new byte[fStream.Length];
				fStream.Read(contents, 0, (int)fStream.Length);
				return contents;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return contents;
			}

		}

		#endregion ConvertToStream
	
		#region CreateSite
		/// <summary>
		/// 迡嚙踝蕭嚙課鳴蕭TeamSite嚙課鳴蕭嚙踝蕭嚙課鳴蕭Site

		/// </summary>
		/// <param name="strSiteName">TeamSite嚙踝蕭嚙?(嚙踝蕭嚙踝蕭嚙調橘蕭聜漳ite\sz)</param>

		public bool DeleteSite(string dirName)
		{
			SPGlobalAdmin globAdmin=null;
			System.Uri uri=null;
			SPVirtualServer virtualServer=null;
			SPSiteCollection siteCollections=null;
			SPDocumentLibrary myDocLib=null;
			SPListCollection lists=null;

			string strSiteUrl=strServerURL+"/sites/"+dirName;
			string Domain=strDomainName+@"\administrator";
			try
			{
				WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
				
				foreach(SPSite site1 in siteCollections)
				{	
					string SiteName=site1.ServerRelativeUrl;
					if (SiteName!="/")
					{
						siteCollections.Delete(SiteName);
					}
				}

				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				globAdmin = null;
				uri = null;
				virtualServer = null;
				siteCollections = null;
			}


		}
		public bool CreateSite(string strSiteName)
		{
			SPGlobalAdmin globAdmin=null;
			System.Uri uri=null;
			SPVirtualServer virtualServer=null;
			SPSiteCollection siteCollections=null;
			SPDocumentLibrary myDocLib=null;
			SPListCollection lists=null;

			string strSiteUrl=strServerURL+"/sites/"+strSiteName;
			string Domain=strDomainName+@"\administrator";
			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
				siteCollections.Add(strSiteUrl,Domain,"zgx@Sytech.com.cn");
					
				//----嚙踝蕭嚙衛選蕭site嚙編hared document警嚙踝蕭嚙踝蕭--------------------------
				SPWeb web=new SPSite(strServerURL).OpenWeb("sites/"+strSiteName);
				web.AllowUnsafeUpdates = true;
				return true;
				/*
				lists = web.Lists;
				myDocLib=(SPDocumentLibrary)web.Lists["埳嚙踝蕭嚙踝蕭警嚙"];

					
				myDocLib.Fields.Add("DocNumber",SPFieldType.Text,false);
				myDocLib.Fields.Add("StatusCode",SPFieldType.Text,false);
				myDocLib.Fields.Add("Version",SPFieldType.Text,false);
				myDocLib.Fields.Add("Keyword",SPFieldType.Text,false);
				myDocLib.Fields.Add("Title",SPFieldType.Text,false);
				myDocLib.Fields.Add("KMID",SPFieldType.Text,false);
				myDocLib.Fields.Add("OldUrl",SPFieldType.Text,false);	//嚙踝蕭嚙誹隙對蕭嚙衝蛛蕭嚙踝蕭嚙踝蕭驍媢嚙褒堆蕭警嚙踝蕭URL
				myDocLib.Fields.Add("KnowType",SPFieldType.Text,false);	//嚙誰羌塚蕭警嚙踝蕭嚙?
				//--------------------------------------------------------------
				return true;
				*/
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
			finally
			{
				globAdmin=null;
				uri=null;
				virtualServer=null;
				siteCollections=null;

			}

		}


		#endregion CreateSite

		#region ViewSite
		/// <summary>
		/// 薶晾嚙課鳴蕭TeamSite嚙課鳴蕭嚙踝蕭嚙課鳴蕭Site

		/// </summary>
		/// <param name="strSiteName">TeamSite嚙踝蕭嚙?(嚙踝蕭嚙踝蕭嚙調橘蕭聜漳ite\sz)</param>
		public string ViewSite()
		{
			SPGlobalAdmin globAdmin=null;
			System.Uri uri=null;
			SPVirtualServer virtualServer=null;
			SPSiteCollection siteCollections=null;
	
			string strUrl="";
			try
			{
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
				foreach(SPSite site1 in siteCollections)
				{				
					strUrl+="<a href="+site1.Url+">"+site1.Url+"</a><br>";
				}
				return strUrl;
	
			}
			finally
			{
				globAdmin=null;
				uri=null;
				virtualServer=null;
				siteCollections=null;

			}
		}
		#endregion ViewSite

		#region DeleteAllSite
		/// <summary>
		/// 嚙踝蕭嚙踝蕭珨嚙確eamSite嚙課鳴蕭嚙踝蕭嚙課鳴蕭Site

		/// </summary>
		/// <param name="strSiteName">TeamSite嚙踝蕭嚙?(嚙踝蕭嚙踝蕭嚙調橘蕭聜漳ite\sz)</param>
		public void DeleteAllSite()
		{
			SPGlobalAdmin globAdmin=null;
			System.Uri uri=null;
			SPVirtualServer virtualServer=null;
			SPSiteCollection siteCollections=null;
	
			try
			{
				WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();
					
				globAdmin = new SPGlobalAdmin();
				uri = new System.Uri(strServerURL);
				virtualServer = globAdmin.OpenVirtualServer(uri);
				siteCollections = virtualServer.Sites;
					
					
				foreach(SPSite site1 in siteCollections)
				{	
					string SiteName=site1.ServerRelativeUrl;
					if (SiteName!="/")
					{
						siteCollections.Delete(SiteName);
					}
				}
			}
			finally
			{
				globAdmin=null;
				uri=null;
				virtualServer=null;
				siteCollections=null;

			}
		}
		#endregion DeleteAllSite

		#region DeleteFolder

		/// <summary>
		/// 删除目录
		/// </summary>
		/// <param name="strDirName">目录地址(不包含sites/等信息)</param>
		/// <returns></returns>
		public bool DeleteFolder(string strDirName)
		{
			WindowsImpersonationContext wic = CreateIdentity (SPSHelper.GetSpsUid,SPSHelper.GetDomainName,SPSHelper.GetSpsPwd).Impersonate();	
			try
			{
				SPFolderCollection srcFolders = null;
				string strSiteName = @"/sites/" + SPSHelper.GetSiteName;
				SPWeb Myweb=new SPSite(strServerURL).AllWebs[strSiteName];
				Myweb.AllowUnsafeUpdates=true;
				string parentFolder = "";
				if(strDirName.LastIndexOf("/") >= 0) //删除子目录

				{
					parentFolder = strDirName.Substring(0,strDirName.LastIndexOf("/"));
					srcFolders = Myweb.GetFolder(parentFolder).SubFolders;
					srcFolders.Delete(strDirName);
				}
				else //删除根目录

					Myweb.Folders.Delete(strDirName);
				return true;
			}
			finally
			{
				wic.Undo();
			}
		
		}

		private bool DeleteFolder(string strSiteName,string strParentFolder,string strDirName)
		{
			SPFolderCollection srcFolders=null;
			strSiteName=@"/sites/"+strSiteName;
			SPWeb Myweb=new SPSite(strServerURL).AllWebs[strSiteName];
			Myweb.AllowUnsafeUpdates=true;
			srcFolders = Myweb.GetFolder(strParentFolder).SubFolders;
			srcFolders.Delete(strDirName);
			return true;
	
		}
		#endregion DeleteFolder

		#region DeleteFile
		/// <summary>
		/// 嚙褕橘蕭嚙踝蕭shared document嚙踝蕭嚙誰賂蕭嚙踝蕭嚙踝蕭躁
		/// </summary>
		/// <param name="strSiteName">嚙踝蕭躁嚙踝蕭嚙踝蕭痤嚙調橘蕭:sz</param>
		/// <param name="strFileName">嚙踝蕭躁嚙踝蕭 :abc.htm</param>
		private bool DeleteFile(string strSiteName,string strFileName)
		{
			try
			{
				strSiteName=@"/sites/"+strSiteName;
				SPWeb Myweb=new SPSite(strServerURL).AllWebs[strSiteName];
				Myweb.AllowUnsafeUpdates=true;

				SPFileCollection delFiles = Myweb.Folders["Shared%20Documents"].Files;
				
				delFiles.Delete("Shared%20Documents/"+strFileName);
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}

		}
		/// <summary>
		/// 嚙褕橘蕭嚙踝蕭shared document嚙踝蕭嚙誰賂蕭嚙踝蕭躁嚙請蛛蕭硌嚙踝蕭嚙衝?
		/// </summary>
		/// <param name="strSiteName">嚙踝蕭躁嚙踝蕭嚙踝蕭痤嚙調橘蕭:sz</param>
		/// <param name="strFolder">嚙踝蕭躁嚙踝蕭嚙踝蕭痤嚙踝蕭躁嚙?:aaa</param>
		/// <param name="strFileName">嚙踝蕭躁嚙踝蕭 :abc.htm</param>
		private bool DeleteFile(string strSiteName,string strFolder,string strFileName)
		{
			try
			{

				strSiteName=@"/sites/"+strSiteName;
				SPWeb Myweb=new SPSite(strServerURL).AllWebs[strSiteName];
				Myweb.AllowUnsafeUpdates=true;
				//string currFolder="Shared%20Documents/"+strFolder;
				if (Myweb.GetFolder(strFolder).Exists)
				{
					SPFileCollection delFiles = Myweb.GetFolder(strFolder).Files;
					delFiles.Delete(strFolder+"/"+strFileName);
				}
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
		}

		#endregion DeleteFile
			
		#region DeleteTextFile
		/// <summary>
		/// 嚙褕橘蕭嚙踝蕭躁
		/// </summary>
		/// <param name="strSiteName">Site Name :gd</param>
		/// <param name="strFileName">嚙踝蕭躁嚙踝蕭	:aaa.doc</param>
		private bool DeleteTextFile(string strSiteName,string strFileName)
		{
			try
			{
				strSiteName=@"/sites/"+strSiteName;
				SPWeb Myweb=new SPSite(strServerURL).AllWebs[strSiteName];
				Myweb.AllowUnsafeUpdates=true;

				SPFileCollection delFiles = Myweb.Folders["Shared%20Documents"].Files;
				
				delFiles.Delete("Shared%20Documents/"+strFileName);
				return true;
			}
			catch(Exception msg)
			{
				errStr=msg.Message.ToString();
				return false;
			}
				
		}			
		#endregion DelelteTextFile

		#region WebDav
		/// <summary>
		/// 
		/// </summary>
		/// <param name="strFileUrl"></param>
		/// <param name="myStream"></param>
		/// <returns></returns>
		private bool WebDav(string strFileUrl,Stream fStream)
		{
			Stream outStream=null;
			try
			{
					

				System.Uri myURi = new System.Uri(strFileUrl);

				WebRequest req = WebRequest.Create(myURi);
				req.Method = "PUT";
				req.Timeout = System.Threading.Timeout.Infinite;

					
				NetworkCredential userCredential = new NetworkCredential(SPSHelper.GetSpsUid,SPSHelper.GetSpsPwd,SPSHelper.GetDomainName);
				CredentialCache myCache	= new CredentialCache();
				myCache.Add(myURi,"ntlm",userCredential);		
				req.Credentials =myCache;

				//req.Credentials = CredentialCache.DefaultCredentials;
				outStream = req.GetRequestStream();
				//Stream fStream = File1.PostedFile.InputStream;

				//FileStream fs = new FileStream(sfilePath,FileMode.OpenOrCreate);
				    
				CopyStream(fStream,outStream);
				return true;
			}
			catch(Exception ex)
			{
				throw ex;
			}
		}
		#endregion

	}

	/// <summary>
	/// 目录已存在的异常.
	/// </summary>
	public class FolderExistsException : System.Exception
	{
		public FolderExistsException(string message) : base(message)
		{
		}
	}
	/// <summary>
	/// 文档库已存在的异常.
	/// </summary>
	public class DocumentLibraryExistsException : System.Exception
	{
		public DocumentLibraryExistsException(string message) : base(message)
		{
		}
	}
}